unit AsteroidesUnit;

interface

uses SkyLib,Orbites,IniFiles, Mydialog,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

Procedure SetLang;

type
  TAsteroidesForm = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    heure: TEdit;
    minute: TEdit;
    annee: TEdit;
    mois: TEdit;
    jours: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    ParalaxeBox: TCheckBox;
    RadioGroup1: TRadioGroup;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  AsteroidesForm: TAsteroidesForm;
  CurYear,CurrentMonth,CurrentDay : integer;
  CurrentTime,TimeBias,DT_UT,Longitude : double;
  PlanetPath : string;
  AstParalaxe : Boolean;

implementation

var   appmsg : array [1..2] of string;

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
    i : integer;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='asteroid';
with AsteroidesForm do
  with inifile do begin
    Caption:=ReadString(section,'title',deftxt);
    Label1.Caption:=ReadString(section,'t_1',deftxt);
    Label2.Caption:=ReadString(section,'t_2',deftxt);
    Label3.Caption:=ReadString(section,'t_3',deftxt);
    Label4.Caption:=ReadString(section,'t_4',deftxt);
    Label5.Caption:=ReadString(section,'t_5',deftxt);
    Label6.Caption:=ReadString(section,'t_6',deftxt);
    Label7.Caption:=ReadString(section,'t_7',deftxt);
    ParalaxeBox.Caption:=ReadString(section,'t_8',deftxt);
    RadioGroup1.Caption:=ReadString('selcat','t_47',deftxt);
    RadioGroup1.Items[0]:=ReadString('selcat','t_33',deftxt);
    RadioGroup1.Items[1]:=ReadString('selcat','t_17',deftxt);
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','help',deftxt);
    BitBtn3.Caption:=ReadString('buttons','cancel',deftxt);
    for i:=1 to 2 do begin
       appmsg[i]:=ReadString(section,'m_'+trim(inttostr(i)),deftxt);
    end;
  end;
inifile.free;
end;
end;

Procedure InitString;
begin
appmsg[1]:='Termin';
appmsg[2]:='Attention! Ces lements on plus d''un an par rapport  la date de calcul. Voulez-vous continuer ?';
end;

procedure TAsteroidesForm.FormShow(Sender: TObject);
var buf : string;
    dd,min : double;
begin
annee.text:=inttostr(CurYear);
mois.text:=inttostr(currentmonth);
jours.text:=inttostr(currentday);
dd:=Int(currenttime);
min:=abs(currenttime-dd)*60;
if min>=59.5 then begin
     dd:=dd+sgn(currenttime);
     min:=0.0;
end;
min:=Round(min);
heure.text:=inttostr(trunc(dd));
minute.text:=inttostr(trunc(min));
Edit1.Text:=PlanetPath+'\astorb.dat';
buf:=extractfilepath(planetpath);
Edit2.Text:=buf+'externes\asteroides\ast.dat';
ParalaxeBox.Checked:=AstParalaxe;
end;

procedure TAsteroidesForm.BitBtn1Click(Sender: TObject);
var jdt,ar,de,ma,dist,r,elong,phase,q : double;
    i, elemy : integer;
    Astname: string;
    f : TextFile;
    ok : boolean;
begin
if not fileexists(edit1.text) then begin showmessage('? '+edit1.text);exit;end;
CurYear:=strtoint(annee.text);
CurrentMonth:=strtoint(mois.text);
CurrentDay:=strtoint(jours.text);
currenttime:=strtoint(heure.text)+strtoint(minute.text)/60;
jdt:=jd(CurYear,CurrentMonth,CurrentDay,CurrentTime-TimeBias+DT_UT);
AssignFile(f,Edit2.Text);
Rewrite(f);
try
OpenAstorb(edit1.text,elemy);
if (abs(elemy-CurYear)>1) then begin
  ok := MyMessageDlg(appmsg[2], mtConfirmation,[mbYes, mbNo], 0) = mrYes;
end else ok:=true;
i:=0;
if ok then begin
repeat
   inc(i);
   if (i mod 1000)=0 then begin
     Edit1.Text:=inttostr(i);
     Update;
   end;
   InitAsteroide(i,Astname);
   if astname=' ' then break;
   Asteroide(jdt,ar,de,dist,r,elong,phase,ma);
   if ParalaxeBox.Checked then Paralaxe(SidTim(jd(CurYear,CurrentMonth,CurrentDay,0.0)
                             ,CurrentTime-TimeBias,Longitude)
                             ,dist,ar,de,ar,de,q);
   writeln(f,Astname,jdt:12:4,artostr(ar),detostr3(de),ma:5:2);
until false;
Edit1.Text:=inttostr(i-1)+' '+appmsg[1];
end;
finally
CloseFile(f);
CloseAstorb;
end;
if ok then ModalResult:=mrOk;
end;

procedure TAsteroidesForm.FormCreate(Sender: TObject);
begin
InitString;
SetLang;
end;

procedure TAsteroidesForm.BitBtn2Click(Sender: TObject);
begin
showhelp('doc3.html#astmasse');
end;

end.
