unit Catalog2Unit;

interface

uses   SkyLib,SelCatUnit,Math, MyDialog,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type Cat2rec =  record ar,de,diam,coef : double ;
                       nom,num,desc1,desc2,desc3 : string;
                       couleur,forme,log : char;
                end;

Procedure OpenCat2(var ok : boolean);
Procedure ReadCat2(var lin : Cat2rec; var ObjType : integer; var ok : boolean);
procedure CloseCat2 ;


var
  Cat2Lst : string;

implementation

var
   fcat : TextFile ;
   curCat,nCat,lsep,maxpp : integer;
   FileIsOpen : Boolean = false;
   pp,pl : array [1..13] of integer;
   coef,epoch,jdi : double;
   couleur,forme,log : char;
   NomCat,Fmt,sep : string;
   ARtype,DEtype : Char;
   c : array of string;
   tcat : char;
   tpos : integer;

{ deepsky2000 object type }
var TypeD : array[1..30] of integer = (1,2,3,5,4,-1,8,-1,-1,-1,101,102,-1,104,105,106,107,108,109,110,111,112,113,-1,-1,-1,-1,-1,-1,-1);
// -1..8=drawneb ; 100+ipla = planet ; 112=ast ; 113=com;

Procedure CloseCat;
begin
{$I-}
if fileisopen then begin
FileisOpen:=false;
closefile(fcat);
end;
{$I+}
end;

Procedure OpenCat(i : integer ; var ok:boolean);
var buf :string;
    n,p : integer;
begin
ok:=false;
with selcat.stringGrid2 do begin
if fileisopen then CloseCat;
repeat
  if trim(cells[0,curcat])>'' then ok:=true
                              else inc(curCat);
until ok or (curcat>ncat);
i:=curcat;
if ok then begin
   NomCat:=cells[1,i];
   Cat2Lst:=Cat2Lst+' '+NomCat;
   if not FileExists(cells[2,i]) then begin
      MyMessageDlg(commsg[3]+' '+nomcat+' : '+cells[2,i],mtWarning,[mbOk, mbCancel],0);
      ok:=false;
      exit;
   end;
   AssignFile(fcat,cells[2,i]);
   FileMode:=0;
   reset(fcat);
   FileisOpen:=true;
   buf:=cells[3,i];
   if trim(buf)>'' then epoch:=strtofloat(buf) else epoch:=2000;
   buf:=trim(cells[4,i])+'  ';
   ARtype:=buf[1];
   DEtype:=buf[2];
   Fmt:=trim(cells[5,i]);
   if Fmt='' then Fmt:='F';
   Fmt:=Uppercase(Fmt);
   if Fmt='TAB' then sep:=chr($9)
   else if Fmt='SPACE' then sep:=' '
   else sep:=Fmt;
   lsep:=length(sep)-1;
   maxpp:=0;
   buf:=cells[15,i];
   if trim(buf)>'' then coef:=strtofloat(buf) else coef:=60;
   buf:=trim(cells[19,i]);
   if buf>'' then couleur:=buf[1] else couleur:='0';
   buf:=trim(cells[20,i]);
   if buf>'' then begin
       buf:=buf+': ';
       p:=pos(':',buf);
       tcat:=copy(buf,p+1,1)[1];
       case tcat of
       'C' : tpos:=strtoint(copy(buf,1,p-1));
       'D' : tpos:=strtoint(copy(buf,1,p-1));
       else forme:=buf[1];
       end;
   end
   else begin
        forme:='0';
        tcat:=' ';
   end;
   buf:=trim(cells[21,i]);
   if buf>'' then log:=buf[1] else log:='0';
   jdi:=jd(trunc(epoch),1,1,0);
   for n:=1 to 13 do begin
       buf:=cells[n+5,i];
       p:=pos('.',buf);
       if p>0 then begin
          pp[n]:=strtoint(copy(buf,1,p-1));
          pl[n]:=strtoint(copy(buf,p+1,length(buf)));
       end
       else begin
          if trim(buf)>'' then pp[n]:=strtoint(buf)
                          else pp[n]:=0;
          pl[n]:=0;
       end;
       if pp[n]>maxpp then maxpp:=pp[n];
   end;
   if Fmt<>'F' then setlength(c,maxpp+1);
end;
end;
end;

Procedure ReadCat2(var lin : Cat2rec; var ObjType : integer; var ok : boolean);
var
    buf,v : string;
    sde : double;
    i,p : integer;
begin
try
ok:=true;
if ( not FileisOpen) or eof(fcat) then begin
  CloseCat;
  inc(curCat);
  if curCat>nCat then ok:=false
  else begin
    OpenCat(curCat,ok);
  end;
end;
if ok and FileisOpen then  begin
Readln(fcat,buf);
lin.nom:=NomCat;
lin.couleur:=couleur;
lin.forme:=forme;
lin.log:=log;
if Fmt='F' then begin                            // Format fixe
  objtype:=0;  // not yet implemented for F format
  lin.num:=copy(buf,pp[1],pl[1]);
  v:=copy(buf,pp[2],pl[2]);
  if trim(v)>'' then lin.ar:=strtofloat(v) else lin.ar:=0;
  v:=copy(buf,pp[3],pl[3]);
  if trim(v)>'' then lin.ar:=lin.ar+strtofloat(v)/60;
  v:=copy(buf,pp[4],pl[4]);
  if trim(v)>'' then lin.ar:=lin.ar+strtofloat(v)/3600;
  v:=copy(buf,pp[5],pl[5]);
  if trim(v)>'' then sde:=strtofloat(v+'1') else sde:=1;
  v:=copy(buf,pp[6],pl[6]);
  if trim(v)>'' then lin.de:=strtofloat(v)*sde else lin.de:=0;
  v:=copy(buf,pp[7],pl[7]);
  if trim(v)>'' then lin.de:=lin.de+sde*strtofloat(v)/60;
  v:=copy(buf,pp[8],pl[8]);
  if trim(v)>'' then lin.de:=lin.de+sde*strtofloat(v)/3600;
  if pl[9]=0 then lin.diam:=pp[9]
  else begin
    v:= copy(buf,pp[9],pl[9]);
    if trim(v)>'' then lin.diam:=strtofloat(v) else lin.diam:=0;
  end;
  lin.coef:=coef;
  lin.desc1:= copy(buf,pp[11],pl[11]);
  lin.desc2:= copy(buf,pp[12],pl[12]);
  lin.desc3:= copy(buf,pp[13],pl[13]);
end else begin                             // Format variable separateur = sep
  c[0]:='';
  for i:=1 to maxpp do begin
    p:=pos(sep,buf);
    if p>0 then begin
      c[i]:=copy(buf,1,p-1);
      delete(buf,1,p+lsep);
    end
    else c[i]:='';
  end;
  lin.num:=c[pp[1]];
  v:=c[pp[2]];
  if trim(v)>'' then lin.ar:=strtofloat(v) else lin.ar:=0;
  v:=c[pp[3]];
  if trim(v)>'' then lin.ar:=lin.ar+strtofloat(v)/60;
  v:=c[pp[4]];
  if trim(v)>'' then lin.ar:=lin.ar+strtofloat(v)/3600;
  v:=c[pp[5]];
  if trim(v)>'' then sde:=strtofloat(v+'1') else sde:=1;
  v:=c[pp[6]];
  if trim(v)>'' then lin.de:=strtofloat(v)*sde else lin.de:=0;
  v:=c[pp[7]];
  if trim(v)>'' then lin.de:=lin.de+sde*strtofloat(v)/60;
  v:=c[pp[8]];
  if trim(v)>'' then lin.de:=lin.de+sde*strtofloat(v)/3600;
  v:=c[pp[9]];
    if trim(v)>'' then lin.diam:=strtofloat(v) else lin.diam:=0;
  lin.coef:=coef;
  lin.desc1:= c[pp[11]];
  lin.desc2:= c[pp[12]];
  lin.desc3:= c[pp[13]];
  if tcat>' ' then begin
     v:=c[tpos];
     if trim(v)>'' then begin
        objtype:=strtointdef(v,0);
        if objtype<30 then
        case tcat of
        'D' : objtype:=TypeD[objtype];
        end
        else objtype:=-1;
     end;
  end else objtype:=0;
end;
case ARtype of
       '1' :  lin.ar:=lin.ar/15;            // AR en degrs
       '2' :  lin.ar:=radtodeg(lin.ar)/15;  // AR en radians
       // else AR en heures
end;
case DEtype of
       '1' :  lin.de:=lin.de-90;            // DE south polar distance
       '2' :  lin.de:=radtodeg(lin.de)      // DE en radians
       // else DE en degrs
end;
if epoch<>2000 then precession(jdi,jd2000,lin.ar,lin.de);
end;
except
  showmessage('Error in catalog '+Nomcat+crlf+'line='+buf);
  raise;
end;
end;

procedure CloseCat2 ;
begin
curCat:=nCat;
CloseCat;
end;

Procedure OpenCat2(var ok : boolean);
begin
curCat:=1;
nCat:=Selcat.StringGrid2.RowCount;
OpenCat(curCat,ok);
end;


end.
 