unit LoadAstroImage;

interface

uses FileCtrl, math,bigima,SkyLib,Registry,IniFiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,  Buttons, ExtDlgs, Grids, Outline, DirOutln,
  Menus, ComCtrls, SystemControlPack, SystemTreeView;

procedure LoadImage;
Procedure ClearImage;
Procedure SetLang;

type
  TLoadAstroForm = class(TForm)
    Image1: TImage;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Label2: TLabel;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    BitBtn1: TBitBtn;
    Timer1: TTimer;
    Panel1: TPanel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Label4: TLabel;
    ComboBox2: TComboBox;
    Panel2: TPanel;
    FileListBox1: TFileListBox;
    Edit3: TEdit;
    FilterComboBox1: TFilterComboBox;
    Panel3: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Panel4: TPanel;
    Image2: TImage;
    Label5: TLabel;
    Label6: TLabel;
    Label1: TLabel;
    SavePictureDialog1: TSavePictureDialog;
    RadioGroup1: TRadioGroup;
    SpeedButton1: TSpeedButton;
    BitBtn2: TBitBtn;
    RadioGroup2: TRadioGroup;
    Label7: TLabel;
    Label8: TLabel;
    Panel5: TPanel;
    SpeedButton3: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label9: TLabel;
    SpeedButton6: TSpeedButton;
    Panel6: TPanel;
    Label11: TLabel;
    Edit4: TEdit;
    UpDown1: TUpDown;
    Label10: TLabel;
    Panel7: TPanel;
    ComboBox3: TComboBox;
    Label12: TLabel;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    Edit5: TEdit;
    Label13: TLabel;
    SystemTreeView1: TSystemTreeView;
    procedure FileListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FileListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure SystemTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure RadioGroup2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LoadAstroForm: TLoadAstroForm;
  imabmp : Tbitmap;
  scalebmp : Tbitmap;
  ctype1,ctype2,radecsys,filename,fi : string;
  projfits : char;
  crpix1,crpix2,crval1,crval2,cdelt1,cdelt2,crota1,crota2 : double;
  cd1_1,cd1_2,cd2_1,cd2_2,equinox : double;
  pc : array [1..2,1..2] of double;
  ar,de,rot,rot1,la : double;
  ImageOK,rotaok,cdok,pcok,autoload,autodisplay,autofilter,skipreload,nvlib,UseFlip,invertX,invertY : boolean;
  currentdir : string = '';
  nviewlib : Dword;

implementation

{$R *.DFM}
{ NViewLib : knishita@ibm.net subject: "Help NV", http://einstein.ae.eng.ua.edu/nishita/index.html }
type TNViewLibLoad =function(FileName : PChar; ShowProgress: BooLean):hbitmap; Stdcall;
var  NViewLibLoad: TNViewLibLoad;
//Procedure NViewLibSetCustomLang(pProgress,pError, pLoad, pErrLoad, pWarning : PChar); Stdcall; external 'NViewLib.dll';
//function NViewLibSetLanguage(Lang: PChar): bool; Stdcall; external 'NViewLib.dll';
//function NViewLibLoad(FileName : PChar; ShowProgress: BooLean):hbitmap; Stdcall; external 'NViewLib.dll';
//function NViewLibSaveAsJPG(Quality:Integer; FileName: PChar):bool; Stdcall; external 'NViewLib.dll';
//function Load_JPG(FileName : PChar; ShowProgress: BooLean):hbitmap; Stdcall; external 'NViewLib.dll';
//function Load_GIF(FileName : PChar; ShowProgress: BooLean):hbitmap; Stdcall; external 'NViewLib.dll';

const maxl = 4000;
type
Timai8 = array of array of byte; TPimai8 = ^Timai8;
Timai16 = array of array of smallint; TPimai16 = ^Timai16;
Timai32 = array of array of longint; TPimai32 = ^Timai32;
Timar32 = array of array of single; TPimar32 = ^Timar32;
Timar64 = array of array of double; TPimar64 = ^Timar64;
PICheader = packed record  signature : byte ;
                         version   : byte ;
                         length    : smallint ;
                         name      : array [1..32] of char;
                         aname     : array [1..32] of char;
                         width     : smallint;
                         heigth    : smallint;
                         datalen   : smallint;
                         datatyp   : smallint;
                         orient    : longint;
                         scaleX    : longint;
                         scaleY    : longint;
                         binX      : smallint;
                         binY      : smallint;
                         color     : smallint;
                         date      : array [1..10] of char;
                         time      : array [1..14] of char;
                         HighPix   : smallint;
                         LowPix    : smallint;
                         HighPixd  : smallint;
                         LowPixd   : smallint;
                         ExpTime   : longint;
                         com1      : array [1..80] of char;
                         com2      : array [1..80] of char;
                 end;
var npix,bitpix : integer;
    d8  : array[1..2880] of byte;
    d16 : array[1..1440] of word;
    d32 : array[1..720] of Longword;
    d64 : array[1..360] of Int64;
    PICh : PicHeader;
    imai8,savi8 : Timai8;
    imai16,savi16 : Timai16;
    imai32,savi32 : Timai32;
    imar32,savr32 : Timar32;
    imar64,savr64 : Timar64;
    imatype : integer;
    savmaxi,savmini,dmini,dmaxi,hdmin,hdmax,datmaxi,datmini,scrollscale,scrollrange : double;
    hi,wi,naxis3,curimage,x1,x2,y1,y2,ha,wa : integer;
    Xz1,Xz2,Yz1,Yz2,ox1,ox2,oy1,oy2 : integer;
    lockscroll,zoominit,lockpalette,lockcolor,BMPcolor : boolean;
    itt : array[0..255] of byte;
    msg : string;
    moyenne,sigma,bzero,bscale,savmoyenne,savsigma : extended;
    appmsg : array [1..3] of string;

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
    i : integer;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='images';
with LoadAstroForm do
  with inifile do begin
    Caption:=ReadString(section,'title',deftxt);
    Label3.Caption:=ReadString(section,'t_1',deftxt);
    Label4.Caption:=ReadString(section,'t_2',deftxt);
    Label7.Caption:=ReadString(section,'t_3',deftxt);
    Label8.Caption:=ReadString(section,'t_4',deftxt);
    RadioGroup1.Caption:=ReadString(section,'t_5',deftxt);
    RadioGroup1.Items[0]:=ReadString(section,'t_6',deftxt);
    RadioGroup1.Items[1]:=ReadString(section,'t_7',deftxt);
    RadioGroup2.Caption:=ReadString(section,'t_8',deftxt);
    RadioGroup2.Items[0]:=ReadString(section,'t_9',deftxt);
    RadioGroup2.Items[1]:=ReadString(section,'t_10',deftxt);
    RadioGroup2.Items[2]:=ReadString(section,'t_11',deftxt);
    RadioGroup2.Items[3]:=ReadString(section,'t_12',deftxt);
    BitBtn1.Caption:=ReadString(section,'t_13',deftxt);
    BitBtn2.Caption:=ReadString('buttons','help',deftxt);
    BitBtn3.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn4.Caption:=ReadString('buttons','cancel',deftxt);
    SpeedButton1.Caption:=ReadString(section,'t_14',deftxt);
    SpeedButton4.Caption:=ReadString(section,'t_15',deftxt);
    SpeedButton5.Caption:=ReadString(section,'t_16',deftxt);
    Label9.Caption:=ReadString(section,'t_17',deftxt);
    Label11.Caption:=ReadString(section,'t_18',deftxt);
    Label12.Caption:=ReadString(section,'t_19',deftxt);
    Label13.Caption:=ReadString(section,'t_20',deftxt);
    for i:=1 to 3 do begin
       appmsg[i]:=ReadString(section,'m_'+trim(inttostr(i)),deftxt);
    end;
  end;
inifile.free;
end;
end;

Procedure InitString;
begin
appmsg[1]:='Mot cl';
appmsg[2]:='manquant';
appmsg[3]:='Erreur de cration de la palette';
end;

Procedure SetScale(onoff : boolean);
var P : PbyteArray;
    j : integer;
begin
LoadAstroForm.edit1.enabled:=onoff;
LoadAstroForm.edit2.enabled:=onoff;
LoadAstroForm.Scrollbar1.enabled:=onoff;
LoadAstroForm.Scrollbar2.enabled:=onoff;
LoadAstroForm.RadioGroup2.enabled:=onoff;
LoadAstroForm.SpeedButton4.enabled:=onoff;
LoadAstroForm.SpeedButton5.enabled:=onoff;
LoadAstroForm.ComboBox1.enabled:=onoff;
LoadAstroForm.ComboBox2.enabled:=onoff;
Loadastroform.SpeedButton2.enabled:=onoff;
Loadastroform.SpeedButton3.enabled:=onoff;
Loadastroform.SpeedButton6.enabled:=onoff;
LoadAstroForm.SpeedButton7.enabled:=onoff;
LoadAstroForm.SpeedButton8.enabled:=onoff;
LoadAstroForm.edit4.enabled:=onoff;
LoadAstroForm.updown1.enabled:=onoff;
if onoff then begin

end else begin
   P:=scalebmp.ScanLine[0];
   for j := 0 to scalebmp.width-1 do begin
       P[j]   := 0;
   end;
   LoadAstroForm.image2.canvas.stretchdraw(Rect(0,0,LoadAstroForm.image2.Width,LoadAstroForm.image2.Height),scalebmp);
   loadastroform.label1.caption:=' ';
   loadastroform.label2.caption:=' ';
end;
end;

Function IsFitsExt(ext:string):boolean;
begin
result:=false;
if (ext='.fts') or
   (copy(ext,2,3)='fit')
   then result:=true;
end;

procedure Showfitsheader(nom : string; var ok : boolean);
var   header : array[1..36,1..80] of char;
      i,n,p1 : integer;
      eoh,ItsFits : boolean;
      keyword : string;
      f : file;
begin
ok:=false;
ItsFits:=false;
filemode:=0;
assignfile(f,nom);
reset(f,1);
if bigimaform=nil then Application.CreateForm(TBigImaForm, BigImaForm);
bigimaform.memo1.Clear;
eoh:=false;
repeat
   blockread(f,header,sizeof(header),n);
   for i:=1 to 36 do begin
      p1:=pos('=',header[i]);
      if p1=0 then p1:=9;
      keyword:=trim(copy(header[i],1,p1-1));
      if (keyword='SIMPLE') then itsFits:=true;
      if (keyword='END') then eoh:=true;
      bigimaform.memo1.lines.Append(header[i]);
   end;
   if not ItsFits then begin msg:=appmsg[1]+' "SIMPLE = T" '+appmsg[2];Closefile(f);Exit;end;
until eoh;
Closefile(f);
ok:=true;
end;

Procedure GalacticToEquator(l,b : double; var ar,de,r : double);
var   alg,deg,lap,al0,de0 : double;
begin
  alg:=degtorad(192.25);
  deg:=degtorad(27.4);
  lap:=123.0;
  al0:=degtorad(12.25)+arctan2(sin(degtorad(l-lap)),cos(degtorad(l-lap))*sin(deg)-tan(degtorad(b))*cos(deg));
  de0:=arcsin(sin(degtorad(b))*sin(deg)+cos(degtorad(b))*cos(deg)*cos(degtorad(l-lap)));
  R:=radtodeg(arctan(cos(deg)*sin(al0-alg)/(cos(de0)*sin(deg)-sin(de0)*cos(deg)*cos(al0-alg))));
  ar:=radtodeg(al0)/15;
  de:=radtodeg(de0);
end;

Procedure FITSCoord;
var   cmethod : integer;
      ic,jc,x,y,cosr,sinr,R : double;
      buf : string;
begin
la:=0;
if (copy(ctype1,2,4)='RA--')and(copy(ctype2,2,4)='DEC-') then begin
  buf:=copy(ctype1,6,4);
  if buf='-TAN' then projfits:='T'
  else if buf='-SIN' then projfits:='S'
  else if buf='-ARC' then projfits:='A'
  else if buf='-CAR' then projfits:='C'
  else projfits:='A';
  if pcok then cmethod:=1
  else
  if cdok then cmethod:=2
  else
  if rotaok then cmethod:=3
  else cmethod:=99;
  ic:=(x1+(wa/2))-crpix1;
  jc:=(hi-y1-(ha/2))-crpix2;
  case cmethod of
  1 : begin
        x:=pc[1,1]*ic + pc[1,2]*jc;
        y:=pc[2,1]*ic + pc[2,2]*jc;
        de:=(crval2 + y*cdelt2);
        ar:=(crval1 + x*cdelt1/cos(degtorad(de)) )/15;
        x:=radtodeg( arctan( (cdelt2/cdelt1)*(pc[2,1]/pc[1,1]) ) );
        y:=radtodeg( arctan(-(cdelt1/cdelt2)*(pc[1,2]/pc[2,2]) ) );
        rot1:=-(x+y)/2;
        la:=abs(wa*cdelt1);
      end;
  2 : begin
        x:=cd1_1*ic + cd1_2*jc;
        y:=cd2_1*ic + cd2_2*jc;
        de:=(crval2 + y);
        ar:=(crval1 + x/cos(degtorad(de)) )/15;
        x:=radtodeg(arctan2(cd2_1,cd1_1));
        y:=radtodeg(arctan2(-cd1_2,cd2_2));
        rot1:=-(x+y)/2;
        la:=abs(wa*cd1_1);
      end;
  3 : begin
        rot1:=-crota2;
        cosr:=cos(degtorad(rot1));
        sinr:=sin(degtorad(rot1));
        x:=cdelt1*ic*cosr+cdelt2*jc*sinr;
        y:=cdelt2*jc*cosr-cdelt1*ic*sinr;
        de:=(crval2 + y);
        ar:=(crval1 + x/cos(degtorad(de)) )/15;
        la:=abs(wa*cdelt1);
      end;
  else la:=0;
  end;
{  if projfits<>'-' then begin
     ArRef:=crval1/15;
     DeRef:=crval2;
  end; }
end;
if (copy(ctype1,2,4)='GLON')and(copy(ctype2,2,4)='GLAT') then begin
  buf:=copy(ctype1,6,4);
  if buf='-TAN' then projfits:='T'
  else if buf='-SIN' then projfits:='S'
  else if buf='-ARC' then projfits:='A'
  else if buf='-CAR' then projfits:='C'
  else projfits:='A';
  if pcok then cmethod:=1
  else
  if cdok then cmethod:=2
  else
  if rotaok then cmethod:=3
  else cmethod:=99;
  ic:=(x1+(wa/2))-crpix1;
  jc:=(hi-y1-(ha/2))-crpix2;
  case cmethod of
  1 : begin
        x:=pc[1,1]*ic + pc[1,2]*jc;
        y:=pc[2,1]*ic + pc[2,2]*jc;
        de:=(crval2 + y*cdelt2);
        ar:=(crval1 + x*cdelt1/cos(degtorad(de)) );
        x:=radtodeg( arctan( (cdelt2/cdelt1)*(pc[2,1]/pc[1,1]) ) );
        y:=radtodeg( arctan(-(cdelt1/cdelt2)*(pc[1,2]/pc[2,2]) ) );
        rot1:=-(x+y)/2;
        la:=abs(wa*cdelt1);
      end;
  2 : begin
        x:=cd1_1*ic + cd1_2*jc;
        y:=cd2_1*ic + cd2_2*jc;
        de:=(crval2 + y);
        ar:=(crval1 + x/cos(degtorad(de)) );
        x:=radtodeg(arctan(cd2_1/cd1_1));
        y:=radtodeg(arctan(-cd1_2/cd2_2));
        rot1:=-(x+y)/2;
        la:=abs(wa*cd1_1);
      end;
  3 : begin
        rot1:=-crota2;
        cosr:=cos(degtorad(rot1));
        sinr:=sin(degtorad(rot1));
        x:=cdelt1*ic*cosr+cdelt2*jc*sinr;
        y:=cdelt2*jc*cosr-cdelt1*ic*sinr;
        de:=(crval2 + y);
        ar:=(crval1 + x/cos(degtorad(de)) );
        la:=abs(wa*cdelt1);
      end;
  else la:=0;
  end;
  GalacticToEquator(ar,de,ar,de,R);
  rot1:=rot1-R;
{  if projfits<>'-' then begin
     GalacticToEquator(crval1,crval2,arRef,deRef,R);
  end;}
end;
  if equinox<>2000 then
     if (copy(radecsys,2,3)='FK4') then precessionFK4(jd(trunc(equinox),round(frac(equinox)*12),1,0),jd2000,ar,de)
                                   else precession(jd(trunc(equinox),round(frac(equinox)*12),1,0),jd2000,ar,de);
end;

procedure Readfitsheader(var f : file; var h,w,px : integer ;var dmin,dmax,blank : double;var bzero,bscale :extended);
var   header : array[1..36,1..80] of char;
      i,n,p1,p2 : integer;
      eoh,ItsFits : boolean;
      keyword,buf : string;
begin
ItsFits:=false;eoh:=false; h:=0 ; w:=0 ; naxis3:=1; px:=0 ; dmin:=0 ; dmax := 0; blank:=0;
bzero:=0 ; bscale:=1;
ctype1:='' ;ctype2:='';
crpix1:=0;crpix2:=0;crval1:=0;crval2:=0;cdelt1:=0;cdelt2:=0;crota1:=0;crota2:=0;
cd1_1:=0;cd2_2:=0;cd1_2:=0;cd2_1:=0;
pc[1,1]:=1;pc[1,2]:=0;pc[2,1]:=0;pc[2,2]:=1;
rotaok:=false;cdok:=false;pcok:=false;
equinox:=0.0;
radecsys:='';
repeat
   blockread(f,header,sizeof(header),n);
   if n<>sizeof(header) then exit;
   for i:=1 to 36 do begin
      p1:=pos('=',header[i]);
      if p1=0 then p1:=9;
      p2:=pos('/',header[i]);
      if p2=0 then p2:=80;
      keyword:=trim(copy(header[i],1,p1-1));
      buf:=trim(copy(header[i],p1+1,p2-p1-1));
      if (keyword='SIMPLE') and (copy(buf,1,1)<>'T') then begin msg:=appmsg[1]+' "SIMPLE = T" '+appmsg[2];Exit;end
                                                     else ItsFits:=true;
      if (keyword='BITPIX') then px:=strtoint(buf);
      if (keyword='NAXIS') and (buf<'2') then begin msg:=appmsg[1]+' "NAXIS < 2"';Exit;end;
      if (keyword='NAXIS1') then begin w:=strtoint(buf);if w=0 then begin msg:=appmsg[1]+' "NAXIS1 = 0"';Exit;end;end;
      if (keyword='NAXIS2') then begin h:=strtoint(buf);if h=0 then begin msg:=appmsg[1]+' "NAXIS2 = 0"';Exit;end;end;
      if (keyword='NAXIS3') then naxis3:=strtoint(buf);
      if (keyword='BZERO') then bzero:=strtofloat(buf);
      if (keyword='BSCALE') then bscale:=strtofloat(buf);
      if (keyword='DATAMAX') then dmax:=strtofloat(buf);
      if (keyword='DATAMIN') then dmin:=strtofloat(buf);
      if (keyword='THRESH') then dmax:=strtofloat(buf);
      if (keyword='THRESL') then dmin:=strtofloat(buf);
      if (keyword='BLANK') then blank:=strtofloat(buf);
      if (keyword='CTYPE1') then ctype1:=buf;
      if (keyword='CTYPE2') then ctype2:=buf;
      if (keyword='CRPIX1') then crpix1:=strtofloat(buf);
      if (keyword='CRPIX2') then crpix2:=strtofloat(buf);
      if (keyword='CRVAL1') then crval1:=strtofloat(buf);
      if (keyword='CRVAL2') then crval2:=strtofloat(buf);
      if (keyword='CDELT1') then begin cdelt1:=strtofloat(buf); rotaok:=true;end;
      if (keyword='CDELT2') then begin cdelt2:=strtofloat(buf); rotaok:=true;end;
      if (keyword='CROTA1') then crota1:=strtofloat(buf);
      if (keyword='CROTA2') then begin crota2:=strtofloat(buf); rotaok:=true;end;
      if (keyword='CD1_1') then begin cd1_1:=strtofloat(buf); cdok:=true; end;
      if (keyword='CD1_2') then begin cd1_2:=strtofloat(buf); cdok:=true; end;
      if (keyword='CD2_1') then begin cd2_1:=strtofloat(buf); cdok:=true; end;
      if (keyword='CD2_2') then begin cd2_2:=strtofloat(buf); cdok:=true; end;
      if (keyword='PC001001') then begin pc[1,1]:=strtofloat(buf); pcok:=true; end;
      if (keyword='PC001002') then begin pc[1,2]:=strtofloat(buf); pcok:=true; end;
      if (keyword='PC002001') then begin pc[2,1]:=strtofloat(buf); pcok:=true; end;
      if (keyword='PC002002') then begin pc[2,2]:=strtofloat(buf); pcok:=true; end;
      if (keyword='EPOCH')or(keyword='EQUINOX') then begin
                   if copy(buf,3,4)='2000' then equinox:=2000
                   else if copy(buf,3,4)='1950' then equinox:=1950
                   else equinox:=strtofloat(buf);
                   end;
      if (keyword='RADECSYS') then radecsys:=buf;
      if (keyword='END') then eoh:=true;
   end;
   if px=0 then exit;
   if not ItsFits then begin msg:=appmsg[1]+' "SIMPLE = T" '+appmsg[2];Exit;end;
until eoh;
if rotaok and (cdelt1>0) then invertX:=true;
if rotaok and (cdelt2<0) then invertY:=true;
LoadAstroForm.SpeedButton2.Down:=InvertY;
LoadAstroForm.SpeedButton3.Down:=InvertX;
if radecsys='' then radecsys:='''FK4''';
if (equinox=0) then if (copy(radecsys,2,3)='FK4') then equinox:=1950
                                                  else equinox:=2000;
end;

Procedure ReadFitsImage(nom : string;var h,w :integer;var dmin,dmax : double);
var i,ii,j,n,px : integer;
    x,blank : double;
    f : file;
    ni,sum,sum2 : extended;
begin
filemode:=0;
assignfile(f,nom);
reset(f,1);
readfitsheader(f,h,w,px,hdmin,hdmax,blank,bzero,bscale);
if h=0 then exit;
bitpix:=px;
dmin:=1.0E100;
dmax:=-1.0E100;
npix:=0;
sum:=0; sum2:=0; ni:=0;
curimage:=trunc(minvalue([curimage,naxis3]));
curimage:=trunc(maxvalue([curimage,1]));
case px of
  -64 : begin
        setlength(imar64,trunc(minvalue([maxl,h])),trunc(minvalue([maxl,w])));
        seek(f,filepos(f)+h*w*8*(curimage-1));
        end;
  -32 : begin
        setlength(imar32,trunc(minvalue([maxl,h])),trunc(minvalue([maxl,w])));
        seek(f,filepos(f)+h*w*4*(curimage-1));
        end;
    8 : begin
        setlength(imai8,trunc(minvalue([maxl,h])),trunc(minvalue([maxl,w])));
        seek(f,filepos(f)+h*w*(curimage-1));
        end;
   16 : begin
        setlength(imai16,trunc(minvalue([maxl,h])),trunc(minvalue([maxl,w])));
        seek(f,filepos(f)+h*w*2*(curimage-1));
        end;
   32 : begin
        setlength(imai32,trunc(minvalue([maxl,h])),trunc(minvalue([maxl,w])));
        seek(f,filepos(f)+h*w*4*(curimage-1));
        end;
end;
case px of
    -64: for i:=0 to h-1 do begin
         ii:=h-1-i;
         for j := 0 to w-1 do begin
           if (npix mod 360 = 0) then begin
             BlockRead(f,d64,sizeof(d64),n);
             npix:=0;
           end;
           inc(npix);
           x:=InvertF64(d64[npix]);
           if x=blank then x:=0;
           if (ii<=maxl-1) and (j<=maxl-1) then imar64[ii,j] := x ;
           x:=bzero+bscale*x;
           dmin:=minvalue([x,dmin]);
           dmax:=maxvalue([x,dmax]);
           sum:=sum+x;
           sum2:=sum2+x*x;
           ni:=ni+1;
         end;
         end;
    -32: for i:=0 to h-1 do begin
         ii:=h-1-i;
         for j := 0 to w-1 do begin
           if (npix mod 720 = 0) then begin
             BlockRead(f,d32,sizeof(d32),n);
             npix:=0;
           end;
           inc(npix);
           x:=InvertF32(d32[npix]);
           if x=blank then x:=0;
           if (ii<=maxl-1) and (j<=maxl-1) then imar32[ii,j] := x ;
           x:=bzero+bscale*x;
           dmin:=minvalue([x,dmin]);
           dmax:=maxvalue([x,dmax]);
           sum:=sum+x;
           sum2:=sum2+x*x;
           ni:=ni+1;
         end;
         end;
     8 : for i:=0 to h-1 do begin
         ii:=h-1-i;
         for j := 0 to w-1 do begin
           if (npix mod 2880 = 0) then begin
             BlockRead(f,d8,sizeof(d8),n);
             npix:=0;
           end;
           inc(npix);
           x:=d8[npix];
           if x=blank then x:=0;
           if (ii<=maxl-1) and (j<=maxl-1) then imai8[ii,j] := round(x);
           x:=bzero+bscale*x;
           dmin:=minvalue([x,dmin]);
           dmax:=maxvalue([x,dmax]);
           sum:=sum+x;
           sum2:=sum2+x*x;
           ni:=ni+1;
         end;
         end;
     16 : for i:=0 to h-1 do begin
         ii:=h-1-i;
         for j := 0 to w-1 do begin
           if (npix mod 1440 = 0) then begin
             BlockRead(f,d16,sizeof(d16),n);
             npix:=0;
           end;
           inc(npix);
           x:=InvertI16(d16[npix]);
           if x=blank then x:=0;
           if (ii<=maxl-1) and (j<=maxl-1) then imai16[ii,j] := round(x);
           x:=bzero+bscale*x;
           dmin:=minvalue([x,dmin]);
           dmax:=maxvalue([x,dmax]);
           sum:=sum+x;
           sum2:=sum2+x*x;
           ni:=ni+1;
         end;
         end;
     32 : for i:=0 to h-1 do begin
         ii:=h-1-i;
         for j := 0 to w-1 do begin
           if (npix mod 720 = 0) then begin
             BlockRead(f,d32,sizeof(d32),n);
             npix:=0;
           end;
           inc(npix);
           x:=InvertI32(d32[npix]);
           if x=blank then x:=0;
           if (ii<=maxl-1) and (j<=maxl-1) then imai32[ii,j] := round(x);
           x:=bzero+bscale*x;
           dmin:=minvalue([x,dmin]);
           dmax:=maxvalue([x,dmax]);
           sum:=sum+x;
           sum2:=sum2+x*x;
           ni:=ni+1;
         end;
         end;
     else begin msg:=appmsg[1]+' "BITPIX = '+inttostr(px)+'" ?'; end;
end;
closefile(f);
h:=trunc(minvalue([maxl,h]));
w:=trunc(minvalue([maxl,w]));
moyenne:=sum/ni;
sigma:=sqrt( (sum2/ni)-(moyenne*moyenne) );
end;

Procedure ShowPICHeader(nom : string; var ok : boolean);
var n : integer;
    f : file;
    buf : string;
begin
ok:=false;
filemode:=0;
assignfile(f,nom);
reset(f,1);
if bigimaform=nil then Application.CreateForm(TBigImaForm, BigImaForm);
bigimaform.memo1.Clear;
BlockRead(f,PICh,sizeof(PICh),n);
buf:='Signature           '+inttohex(pich.signature,4);
bigimaform.memo1.lines.Append(buf);
buf:='Version             '+inttohex(pich.version,4);
bigimaform.memo1.lines.Append(buf);
buf:='Dimension du header '+inttostr(pich.length);
bigimaform.memo1.lines.Append(buf);
buf:='Nom de l''image      '+pich.name;
bigimaform.memo1.lines.Append(buf);
buf:='Nom de l''image lie '+pich.aname;
bigimaform.memo1.lines.Append(buf);
buf:='Nombre de colonnes  '+inttostr(pich.width);
bigimaform.memo1.lines.Append(buf);
buf:='Nombre de lignes    '+inttostr(pich.heigth);
bigimaform.memo1.lines.Append(buf);
buf:='Dimension donnes   '+inttostr(pich.datalen);
bigimaform.memo1.lines.Append(buf);
buf:='Type de donnes     '+inttostr(pich.datatyp);
bigimaform.memo1.lines.Append(buf);
buf:='Orientation         '+floattostr(pich.orient);
bigimaform.memo1.lines.Append(buf);
buf:='Echelle en X        '+floattostr(pich.scalex);
bigimaform.memo1.lines.Append(buf);
buf:='Echelle en Y        '+floattostr(pich.scaley);
bigimaform.memo1.lines.Append(buf);
buf:='Binning en X        '+inttostr(pich.binx);
bigimaform.memo1.lines.Append(buf);
buf:='Binning en Y        '+inttostr(pich.biny);
bigimaform.memo1.lines.Append(buf);
buf:='Plans couleurs      '+inttostr(pich.color);
bigimaform.memo1.lines.Append(buf);
buf:='Date                '+pich.date;
bigimaform.memo1.lines.Append(buf);
buf:='Heure               '+pich.time;
bigimaform.memo1.lines.Append(buf);
buf:='Seuil haut          '+inttostr(pich.highpix);
bigimaform.memo1.lines.Append(buf);
buf:='Seuil bas           '+inttostr(pich.lowpix);
bigimaform.memo1.lines.Append(buf);
buf:='Fract. seuil haut   '+inttostr(pich.highpixd);
bigimaform.memo1.lines.Append(buf);
buf:='Fract. seuil bas    '+inttostr(pich.lowpixd);
bigimaform.memo1.lines.Append(buf);
buf:='Temps d''intgration '+floattostr(pich.exptime);
bigimaform.memo1.lines.Append(buf);
buf:='Commentaire 1       '+pich.com1;
bigimaform.memo1.lines.Append(buf);
buf:='Commentaire 2       '+pich.com2;
bigimaform.memo1.lines.Append(buf);
closefile(f);
ok:=true;
end;

Procedure ReadPICHeader(var f : file ; var h,w,px : integer; var hdmin,hdmax : double);
var n : integer;
begin
 h:=0; w:=0; px:=0; hdmin:=0; hdmax:=0;
 BlockRead(f,PICh,sizeof(PICh),n);
 if pich.datatyp<>3 then begin msg:='PIC data type ='+inttostr(pich.datatyp);Exit;end;
 case pich.datalen of
      2 : px:=16;
      4 : px:=32;
      16: px:=16;
      32: px:=32;
      else begin msg:='PIC data length ='+inttostr(pich.datalen);Exit;end;
 end;
 h:=PICh.heigth;
 w:=PICh.width;
 hdmin:=PICh.LowPix;
 hdmax:=PICh.HighPix;
end;

Procedure ReadPICImage(nom : string;var h,w :integer;var dmin,dmax : double);
const nrec = 512;
var i,ii,j,n,px : integer;
    p16 : array [1..nrec] of smallint;
    p32 : array [1..nrec] of single;
    x : double;
    f : file;
    ni,sum,sum2 : extended;
begin
filemode:=0;
assignfile(f,nom);
reset(f,1);
readPICheader(f,h,w,px,hdmin,hdmax);
if h=0 then exit;
bitpix:=px;
npix:=0;
dmin:=1.0E100;
dmax:=-1.0E100;
sum:=0; sum2:=0; ni:=0;
curimage:=1;
naxis3:=1;
bzero:=0;
bscale:=1;
case px of
16 : setlength(imai16,trunc(minvalue([maxl,h])),trunc(minvalue([maxl,w])));
32 : setlength(imai32,trunc(minvalue([maxl,h])),trunc(minvalue([maxl,w])));
end;
for i:=0 to h-1 do begin
  ii:=h-1-i;
  for j := 0 to w-1 do begin
     case px of
     16 : begin
           if (npix mod nrec = 0) then begin
             BlockRead(f,p16,sizeof(p16),n);
             npix:=0;
           end;
           inc(npix);
           x:=p16[npix];
           if (ii<=maxl-1) and (j<=maxl-1) then imai16[ii,j] := round(x) ;
          end;
     32 : begin
           if (npix mod nrec = 0) then begin
             BlockRead(f,p32,sizeof(p32),n);
             npix:=0;
           end;
           inc(npix);
           x:=p32[npix];
           if (ii<=maxl-1) and (j<=maxl-1) then imai32[ii,j] := round(x) ;
          end;
     else x:=1;
     end;
     dmin:=minvalue([x,dmin]);
     dmax:=maxvalue([x,dmax]);
     sum:=sum+x;
     sum2:=sum2+x*x;
     ni:=ni+1;
  end;
end;
closefile(f);
h:=trunc(minvalue([maxl,h]));
w:=trunc(minvalue([maxl,w]));
moyenne:=sum/ni;
sigma:=sqrt( (sum2/ni)-(moyenne*moyenne) );
end;

Procedure SetColorBMP(nom : string;var h,w :integer;var dmin,dmax : double; var tempbmp : TBitMap);
begin
   imabmp.Assign(tempbmp);
   LoadAstroForm.image1.width:=round(LoadAstroForm.image1.Height*(imabmp.width/imabmp.height));
   LoadAstroForm.image1.canvas.stretchdraw(Rect(0,0,LoadAstroForm.image1.Width,LoadAstroForm.image1.Height),imabmp);
   imageOK:=true;
   case imabmp.pixelformat of
        pf1bit : BitPix:=1;
        pf4bit : BitPix:=4;
        pf8bit : BitPix:=8;
        pf15bit : BitPix:=15;
        pf16bit : BitPix:=16;
        pf24bit : BitPix:=24;
        pf32bit : BitPix:=32;
        else bitpix:=0;
   end;
   SetScale(false);
   loadastroform.label2.caption:=extractfilename(nom)+'  '+inttostr(imabmp.width)+'x'+inttostr(imabmp.Height)+'  '+inttostr(bitpix)+' bits';
   h:=0; w:=0;
   BMPcolor:=true;
end;

Procedure ReadBMPimage(nom : string;var h,w :integer;var dmin,dmax : double);
var tempbmp : Tbitmap;
    P : PbyteArray;
    i,j,x : integer;
    tmpfile : string;
    ni,sum,sum2 : extended;
begin
h:=0;w:=0;
bzero:=0;
bscale:=1;
tempbmp:=Tbitmap.create;
if lowercase(extractfileext(nom))='.bmp' then begin
    tempbmp.Loadfromfile(nom);
end else if nvlib then begin
//    NViewLibSetLanguage(PChar('French'));
    tempbmp.Handle:=NViewLibLoad(PChar(nom),false);
    tmpfile:=changefileext(GetTempFile($1000),'.bmp');
    tempbmp.PixelFormat:=pf24bit;
    tempbmp.savetofile(tmpfile);
    tempbmp.Loadfromfile(tmpfile);
    DeleteFile(tmpfile);
end;
if tempbmp.empty then exit;
if loadastroform.RadioGroup1.itemindex=0 then begin
   SetColorBMP(nom,h,w,dmin,dmax,tempbmp);
   tempbmp.free;
   if lowercase(extractfileext(nom))='.bmp' then filename:=nom;
   curimage:=1;
   naxis3:=1;
   exit;
end;
h:=tempbmp.height;
w:=tempbmp.width;
setlength(imai8,h,w);
hdmin:=0;
hdmax:=255;
dmin:=1.0E100;
dmax:=-1.0E100;
sum:=0; sum2:=0; ni:=0;
case tempbmp.pixelformat of
pf8bit : begin
   bitpix:=8;
   curimage:=1;
   naxis3:=1;
   for i:=0 to tempbmp.height-1 do begin
      P:=tempbmp.ScanLine[i];
      for j:=0 to tempbmp.width-1 do begin
         x:=P[j];
         dmin:=trunc(minvalue([x,dmin]));
         dmax:=trunc(maxvalue([x,dmax]));
         sum:=sum+x;
         sum2:=sum2+x*x;
         ni:=ni+1;
         imai8[i,j]:=x;
      end;
   end;
   end;
pf15bit,pf16bit : begin
   bitpix:=8;
   curimage:=1;
   naxis3:=1;
   for i:=0 to tempbmp.height-1 do begin
      P:=tempbmp.ScanLine[i];
      for j:=0 to (tempbmp.width-1) do begin
         x:=((P[2*j])+(P[2*j+1])) div 2;
         dmin:=trunc(minvalue([x,dmin]));
         dmax:=trunc(maxvalue([x,dmax]));
         sum:=sum+x;
         sum2:=sum2+x*x;
         ni:=ni+1;
         imai8[i,j]:=x;
      end;
   end;
   end;
pf24bit : begin
   bitpix:=8;
   naxis3:=3;
   curimage:=trunc(minvalue([curimage,naxis3]));
   curimage:=trunc(maxvalue([curimage,0]));
   for i:=0 to tempbmp.height-1 do begin
      P:=tempbmp.ScanLine[i];
      for j:=0 to (tempbmp.width-1) do begin
         case curimage of
           1 : x:=P[3*j+2];
           2 : x:=P[3*j+1];
           3 : x:=P[3*j];
           else x:=(P[3*j]+P[3*j+1]+P[3*j+2]) div 3;
         end;
         dmin:=trunc(minvalue([x,dmin]));
         dmax:=trunc(maxvalue([x,dmax]));
         sum:=sum+x;
         sum2:=sum2+x*x;
         ni:=ni+1;
         imai8[i,j]:=x;
      end;
   end;
   end;
pf32bit : begin
   bitpix:=8;
   naxis3:=1;
   for i:=0 to tempbmp.height-1 do begin
      P:=tempbmp.ScanLine[i];
      for j:=0 to (tempbmp.width-1) do begin
         x:=(P[4*j]+P[4*j+1]+P[4*j+2]+P[4*j+3]) div 4;
         dmin:=trunc(minvalue([x,dmin]));
         dmax:=trunc(maxvalue([x,dmax]));
         sum:=sum+x;
         sum2:=sum2+x*x;
         ni:=ni+1;
         imai8[i,j]:=x;
      end;
   end;
   end
else begin h:=0;w:=0;sum:=0;sum2:=0;ni:=1 end;
end;
tempbmp.free;
moyenne:=sum/ni;
sigma:=sqrt( (sum2/ni)-(moyenne*moyenne) );
end;

procedure CrePalette(var hpal:HPALETTE);
type
  palentries   = array[0..255] of TPaletteEntry;
  TMyLogPalette = record
    palVersion    : Word;
    palNumEntries : Word;
    palEntry      : palentries;
  end;
var
  pal: TMyLogPalette;
  i: Integer;
  flut : text;
  r,g,b : double;
  fn : string;
begin
fn:=currentdir+'\palettes\'+LoadAstroForm.ComboBox1.text+'.lut';
filemode:=0;
if fileexists(fn) then begin  
  if debugon then writedebug('AssignFile '+fn);
  assignfile(flut,fn);
  if debugon then writedebug('Reset '+fn);
  reset(flut);
    pal.palVersion    := $0300;
    pal.palNumEntries := 256;
    for i := 0 to 255 do begin
       if i=0 then begin
          pal.PalEntry[i].peRed := 0;
          pal.PalEntry[i].peGreen := 0;
          pal.PalEntry[i].peBlue := 0;
          pal.PalEntry[i].peFlags := pc_reserved;
          end
       else begin
          readln(flut,r,g,b);
          pal.PalEntry[i].peRed   := round(r*255);
          pal.PalEntry[i].peGreen := round(g*255);
          pal.PalEntry[i].peBlue  := round(b*255);
          pal.PalEntry[i].peFlags := pc_reserved;
       end;
    end;
  if debugon then writedebug('Close '+fn);
  closefile(flut);
end else begin
  if debugon then writedebug('File not found : '+fn);
  pal.palVersion    := $0300;
  pal.palNumEntries := 256;
  for i := 0 to 255 do begin
        pal.PalEntry[i].peRed := i;
        pal.PalEntry[i].peGreen := i;
        pal.PalEntry[i].peBlue := i;
        pal.PalEntry[i].peFlags := pc_reserved;
  end;
end;
Hpal := CreatePalette(PLogPalette(@pal)^);
if Hpal=0 then begin
  if debugon then writedebug('Invalid palette');
  ShowMessage(appmsg[3]+' '+LoadAstroForm.ComboBox1.text);
end;
end;

procedure DrawImage;
var i,j : integer;
    x : integer;
    xx: extended;
    P : PbyteArray;
    pal : HPALETTE;
    c : double;
begin
imabmp.freeimage;
imabmp.height:=ha;
imabmp.width:=wa;
imabmp.IgnorePalette:=false;
imabmp.pixelformat:=pf8bit;
crePalette(pal);
imabmp.Palette:=pal;
c:=255/(dmaxi-dmini);
case bitpix of
     -64 : for i:=y1 to y1+ha-1 do begin
           if invertY then P:=imabmp.ScanLine[y1+ha-1-i]
                      else P:=imabmp.ScanLine[i-y1];
           for j := x1 to x1+wa-1 do begin
               xx:=bzero+bscale*imar64[i,j];
               x:=trunc(maxvalue([0,minvalue([255,(xx-dmini) * c ])]) );
               if invertX then P[x1+wa-1-j] := itt[x]
                          else P[j-x1] := itt[x] ;
           end;
           end;
     -32 : for i:=y1 to y1+ha-1 do begin
           if invertY then P:=imabmp.ScanLine[y1+ha-1-i]
                      else P:=imabmp.ScanLine[i-y1];
           for j := x1 to x1+wa-1 do begin
               xx:=bzero+bscale*imar32[i,j];
               x:=trunc(maxvalue([0,minvalue([255,(xx-dmini) * c ])]) );
               if invertX then P[x1+wa-1-j] := itt[x]
                          else P[j-x1] := itt[x] ;
           end;
           end;
       8 : for i:=y1 to y1+ha-1 do begin
           if invertY then P:=imabmp.ScanLine[y1+ha-1-i]
                      else P:=imabmp.ScanLine[i-y1];
           for j := x1 to x1+wa-1 do begin
               xx:=bzero+bscale*imai8[i,j];
               x:=trunc(maxvalue([0,minvalue([255,(xx-dmini) * c ])]) );
               if invertX then P[x1+wa-1-j] := itt[x]
                          else P[j-x1] := itt[x] ;
           end;
           end;
      16 : for i:=y1 to y1+ha-1 do begin
           if invertY then P:=imabmp.ScanLine[y1+ha-1-i]
                      else P:=imabmp.ScanLine[i-y1];
           for j := x1 to x1+wa-1 do begin
               xx:=bzero+bscale*imai16[i,j];
               x:=trunc(maxvalue([0,minvalue([255,(xx-dmini) * c ])]) );
               if invertX then P[x1+wa-1-j] := itt[x]
                          else P[j-x1] := itt[x] ;
           end;
           end;
      32 : for i:=y1 to y1+ha-1 do begin
           if invertY then P:=imabmp.ScanLine[y1+ha-1-i]
                      else P:=imabmp.ScanLine[i-y1];
           for j := x1 to x1+wa-1 do begin
               xx:=bzero+bscale*imai32[i,j];
               x:=trunc(maxvalue([0,minvalue([255,(xx-dmini) * c ])]) );
               if invertX then P[x1+wa-1-j] := itt[x]
                          else P[j-x1] := itt[x] ;
           end;
           end;
      end;
end;

Procedure DrawScale;
var j : integer;
    P1 : PbyteArray;
    pal : HPALETTE;
begin
scalebmp.freeimage;
scalebmp.width:=256;
scalebmp.height:=1;
scalebmp.PixelFormat:=pf8Bit;
scalebmp.Ignorepalette:=false;
crePalette(pal);
scalebmp.Palette:=pal;
P1:=scalebmp.ScanLine[0];
for j := 0 to scalebmp.width-1 do begin
   P1[j]   := itt[j] ;
end;
end;

Procedure Redraw;
begin
Screen.cursor:=crHourGlass;
ZoomInit:=false;
FITSCoord;
Loadastroform.label2.caption:=extractfilename(fi)+'  '+inttostr(wa)+'x'+inttostr(ha)+'  '+inttostr(bitpix)+' bits';
if la<>0 then Loadastroform.label2.caption:=Loadastroform.label2.caption+' '+projfits+' ar:'+artostr(ar)+' de:'+detostr(de)+' l:'+detostr(la);
DrawImage;
LoadAstroForm.image1.width:=round(LoadAstroForm.image1.Height*(wa/ha));
LoadAstroForm.image1.canvas.stretchdraw(Rect(0,0,LoadAstroForm.image1.Width,LoadAstroForm.image1.Height),imabmp);
DrawScale;
LoadAstroForm.image2.canvas.stretchdraw(Rect(0,0,LoadAstroForm.image2.Width,LoadAstroForm.image2.Height),scalebmp);
Screen.cursor:=crDefault;
end;

procedure SetITT;
var
  i: Integer;
  fitt : text;
  s : double;
  fn : string;
begin
fn:=currentdir+'\palettes\'+LoadAstroForm.ComboBox2.text+'.itt';
filemode:=0;
if fileexists(fn) then begin  
  if debugon then writedebug('AssignFile '+fn);
  assignfile(fitt,fn);
  if debugon then writedebug('Reset '+fn);
  reset(fitt);
  try
    for i := 1 to 255 do begin
       readln(fitt,s);
       itt[i]:=round(s*255);
    end;
    itt[0]:=itt[1];
  finally
  if debugon then writedebug('Close '+fn);
    closefile(fitt);
  end;
end else begin
  if debugon then writedebug('File not found : '+fn);
  for i := 1 to 255 do begin
       itt[i]:=i;
  end;
  itt[0]:=itt[1];
end;
end;

Procedure ClearImage;
begin
projfits:='-';
la:=0;
LoadAstroForm.label1.Caption:=' ';
LoadAstroForm.label2.Caption:=' ';
setlength(imai8,1,1);
setlength(imai16,1,1);
setlength(imai32,1,1);
setlength(imar32,1,1);
setlength(imar64,1,1);
setlength(savi8,1,1);
setlength(savi16,1,1);
setlength(savi32,1,1);
setlength(savr32,1,1);
setlength(savr64,1,1);
imabmp.assign(scalebmp);
imabmp.width:=1;
imabmp.height:=1;
imabmp.canvas.pixels[0,0]:=0;
LoadAstroForm.image1.canvas.brush.color:=clBlack;
LoadAstroForm.image1.canvas.fillrect(Rect(0,0,LoadAstroForm.image1.Width,LoadAstroForm.image1.Height));
LoadAstroForm.image2.canvas.brush.color:=clBlack;
LoadAstroForm.image2.canvas.fillrect(Rect(0,0,LoadAstroForm.image2.Width,LoadAstroForm.image2.Height));
ImageOK:=false;
end;

Procedure BadImage;
begin
ClearImage;
LoadAstroForm.label2.Caption:='Format non support.'+msg;
LoadAstroForm.label1.Caption:=' ';
end;

Procedure SetRange;
var lowfactor,higfactor : double;
    buf : string;
begin
with loadastroform do begin
  lockscroll:=true;
  if datmaxi=datmini then datmaxi:=datmaxi+1;
  if (hdmax=0) and (hdmin=0) then begin
     hdmax:=datmaxi;
     hdmin:=datmini;
  end;
  if hdmax=hdmin then hdmax:=hdmax+1;
  dmaxi:=hdmax; dmini:=hdmin;
  scrollrange:=maxvalue([abs(datmaxi-datmini),abs(hdmax-hdmin)]);
  scrollscale:=(scrollrange/10000);
  scrollbar1.LargeChange:=3000;
  scrollbar2.LargeChange:=3000;
  scrollbar1.SmallChange:=100;
  scrollbar2.SmallChange:=100;
  scrollbar1.min:=0;
  scrollbar2.min:=0;
  scrollbar1.max:=30000;
  scrollbar2.max:=30000;
case radiogroup2.ItemIndex of
0 : begin  // header
    dmini:=hdmin;
    dmaxi:=hdmax;
    scrollbar1.position:=round(hdmin/scrollscale)+10000;
    scrollbar2.position:=round(hdmax/scrollscale)+10000;
    end;
1 : begin  // data
    dmini:=datmini;
    dmaxi:=datmaxi;
    scrollbar1.position:=round(datmini/scrollscale)+10000;
    scrollbar2.position:=round(datmaxi/scrollscale)+10000;
    end;
2 : begin  // 1 sigma asymetrique
    lowfactor:=2*(moyenne-datmini)/(datmaxi-datmini);
    higfactor:=2*(datmaxi-moyenne)/(datmaxi-datmini);
    dmini:=maxvalue([datmini,moyenne-sigma*lowfactor]);
    scrollbar1.position:=round(dmini/scrollscale)+10000;
    dmaxi:=minvalue([datmaxi,moyenne+sigma*higfactor]);
    scrollbar2.position:=round(dmaxi/scrollscale)+10000;
    end;
3 : begin  // 2 sigma asymetrique
    lowfactor:=2*(moyenne-datmini)/(datmaxi-datmini);
    higfactor:=2*(datmaxi-moyenne)/(datmaxi-datmini);
    dmini:=maxvalue([datmini,moyenne-2*sigma*lowfactor]);
    scrollbar1.position:=round(dmini/scrollscale)+10000;
    dmaxi:=minvalue([datmaxi,moyenne+2*sigma*higfactor]);
    scrollbar2.position:=round(dmaxi/scrollscale)+10000;
    end;
4 : begin  // 70% data asymetrique
    dmini:=datmini+0.3*(moyenne-datmini);
    dmaxi:=datmaxi-0.3*(datmaxi-moyenne);
    scrollbar1.position:=round(dmini/scrollscale)+10000;
    scrollbar2.position:=round(dmaxi/scrollscale)+10000;
    end;
end;
  str(dmini:12:3,buf); edit1.text:=trim(buf);
  str(dmaxi:12:3,buf); edit2.text:=trim(buf);
  lockscroll:=false;
end;
end;

Procedure Filter;
var x,y,ni : integer;
    a : array [1..5,1..5] of double ;
    i,j,m,n : integer;
    k : double;
    c,filtertresh : extended;
    max16,min16 : smallint;
    max32,min32 : longint;
    sum,sum2 : extended;
begin
with loadastroform do begin
filtertresh:=strtofloat(edit5.text);
case combobox3.ItemIndex of
0 : begin
    speedbutton8.Click;
    exit;
    end;
1 : begin a[1,1]:=1; a[1,2]:=1; a[1,3]:=1;
          a[2,1]:=1; a[2,2]:=4; a[2,3]:=1;    // lowpass1
          a[3,1]:=1; a[3,2]:=1; a[3,3]:=1;
          k:=12; n:=3; end;
2 : begin a[1,1]:=1; a[1,2]:=1; a[1,3]:=1;
          a[2,1]:=1; a[2,2]:=1; a[2,3]:=1;    // lowpass2
          a[3,1]:=1; a[3,2]:=1; a[3,3]:=1;
          k:=9; n:=3; end;
3 : begin a[1,1]:=0; a[1,2]:=0;  a[1,3]:=1; a[1,4]:=0;  a[1,5]:=0;
          a[2,1]:=0; a[2,2]:=1;  a[2,3]:=2; a[2,4]:=1;  a[2,5]:=0; // lowpass3
          a[3,1]:=1; a[3,2]:=2;  a[3,3]:=5; a[3,4]:=2;  a[3,5]:=1;
          a[4,1]:=0; a[4,2]:=1;  a[4,3]:=2; a[4,4]:=1;  a[4,5]:=0;
          a[5,1]:=0; a[5,2]:=0;  a[5,3]:=1; a[5,4]:=0;  a[5,5]:=0;
          k:=21; n:=5; end;
4 : begin a[1,1]:=0; a[1,2]:=1;  a[1,3]:=1; a[1,4]:=1;  a[1,5]:=0;
          a[2,1]:=1; a[2,2]:=1;  a[2,3]:=2; a[2,4]:=1;  a[2,5]:=1; // lowpass4
          a[3,1]:=1; a[3,2]:=2;  a[3,3]:=4; a[3,4]:=2;  a[3,5]:=1;
          a[4,1]:=1; a[4,2]:=1;  a[4,3]:=2; a[4,4]:=1;  a[4,5]:=1;
          a[5,1]:=0; a[5,2]:=1;  a[5,3]:=1; a[5,4]:=1;  a[5,5]:=0;
          k:=28; n:=5; end;
5 : begin a[1,1]:=1; a[1,2]:=1;  a[1,3]:=1; a[1,4]:=1;  a[1,5]:=1;
          a[2,1]:=1; a[2,2]:=1;  a[2,3]:=1; a[2,4]:=1;  a[2,5]:=1; // lowpass5
          a[3,1]:=1; a[3,2]:=1;  a[3,3]:=1; a[3,4]:=1;  a[3,5]:=1;
          a[4,1]:=1; a[4,2]:=1;  a[4,3]:=1; a[4,4]:=1;  a[4,5]:=1;
          a[5,1]:=1; a[5,2]:=1;  a[5,3]:=1; a[5,4]:=1;  a[5,5]:=1;
          k:=25; n:=5; end;
6 : begin a[1,1]:=0; a[1,2]:=0.6;  a[1,3]:=1.7; a[1,4]:=0.6;  a[1,5]:=0;
          a[2,1]:=0.6; a[2,2]:=13;  a[2,3]:=36; a[2,4]:=13;  a[2,5]:=0.6; // Gauss
          a[3,1]:=1.7; a[3,2]:=36;  a[3,3]:=100; a[3,4]:=36;  a[3,5]:=1.7;
          a[4,1]:=0.6; a[4,2]:=13;  a[4,3]:=36; a[4,4]:=13;  a[4,5]:=0.6;
          a[5,1]:=0; a[5,2]:=0.6;  a[5,3]:=1.7; a[5,4]:=0.6;  a[5,5]:=0;
          k:=307.6; n:=5; end;
7 : begin a[1,1]:=0; a[1,2]:=-1; a[1,3]:=0;
          a[2,1]:=-1; a[2,2]:=7; a[2,3]:=-1;  // focus1
          a[3,1]:=0; a[3,2]:=-1; a[3,3]:=0;
          k:=3; n:=3; end;
8 : begin a[1,1]:=0; a[1,2]:=-1; a[1,3]:=0;
          a[2,1]:=-1; a[2,2]:=5; a[2,3]:=-1;  // focus2
          a[3,1]:=0; a[3,2]:=-1; a[3,3]:=0;
          k:=1; n:=3; end;
9 : begin a[1,1]:=-1; a[1,2]:=-1; a[1,3]:=-1;
          a[2,1]:=-1; a[2,2]:=9;  a[2,3]:=-1; // focus3
          a[3,1]:=-1; a[3,2]:=-1; a[3,3]:=-1;
          k:=1; n:=3; end;
10 : begin a[1,1]:=-1; a[1,2]:=-1; a[1,3]:=-1;
          a[2,1]:=-1; a[2,2]:=8;  a[2,3]:=-1;   // laplaceedge
          a[3,1]:=-1; a[3,2]:=-1; a[3,3]:=-1;
          k:=1; n:=3; end;
11 : begin a[1,1]:=1;  a[1,2]:=1;  a[1,3]:=1;
          a[2,1]:=-1; a[2,2]:=-2; a[2,3]:=1;    // gradient1
          a[3,1]:=-1; a[3,2]:=-1; a[3,3]:=1;
          k:=1; n:=3; end;
12: begin a[1,1]:=-1; a[1,2]:=-1; a[1,3]:=1;
          a[2,1]:=-1; a[2,2]:=-2; a[2,3]:=1;    // gradient2
          a[3,1]:=1;  a[3,2]:=1;  a[3,3]:=1;
          k:=1; n:=3; end;
13: begin a[1,1]:=-1; a[1,2]:=1; a[1,3]:=0;
          a[2,1]:=-1; a[2,2]:=1; a[2,3]:=0;     // gradient3
          a[3,1]:=-1; a[3,2]:=1; a[3,3]:=0;
          k:=1; n:=3; end;
14: begin a[1,1]:=0; a[1,2]:=0; a[1,3]:=0;
          a[2,1]:=1; a[2,2]:=1; a[2,3]:=1;      // gradient4
          a[3,1]:=-1; a[3,2]:=-1; a[3,3]:=-1;
          k:=1; n:=3; end;
else begin a[1,1]:=0; a[1,2]:=0; a[1,3]:=0;
           a[2,1]:=0; a[2,2]:=1; a[2,3]:=0;    // unit
           a[3,1]:=0; a[3,2]:=0; a[3,3]:=0;
           k:=1; n:=3; end;
end;
datmini:=1.0E100;
datmaxi:=-1.0E100;
ni:=0; sum:=0;sum2:=0;
m:=(n div 2)+1;
case bitpix of
  -64 : begin
        for y:=m-1 to hi-m do begin
          for x:=m-1 to wi-m do begin
            if savr64[y,x]< filtertresh then begin
               c:=0;
               for i :=1 to n do
                 for j :=1 to n do
                   c:=c+a[j,i]*savr64[y-m+i,x-m+j];
               c:= c / k;
               imar64[y,x]:=round(c);
               datmini:=minvalue([c,datmini]);
               datmaxi:=maxvalue([c,datmaxi]);
               sum:=sum+c;
               sum2:=sum2+c*c;
               inc(ni);
            end else imar64[y,x]:=savr64[y,x];
          end;
        end;
        end;
  -32 : begin
        for y:=m-1 to hi-m do begin
          for x:=m-1 to wi-m do begin
            if savr32[y,x]< filtertresh then begin
               c:=0;
               for i :=1 to n do
                 for j :=1 to n do
                   c:=c+a[j,i]*savr32[y-m+i,x-m+j];
               c:= c / k;
               imar32[y,x]:=round(c);
               datmini:=minvalue([c,datmini]);
               datmaxi:=maxvalue([c,datmaxi]);
               sum:=sum+c;
               sum2:=sum2+c*c;
               inc(ni);
            end else imar32[y,x]:=savr32[y,x];
          end;
        end;
        end;
    8 : begin
        for y:=m-1 to hi-m do begin
          for x:=m-1 to wi-m do begin
            if savi8[y,x]< filtertresh then begin
               c:=0;
               for i :=1 to n do
                 for j :=1 to n do
                   c:=c+a[j,i]*savi8[y-m+i,x-m+j];
               c:= c / k;
               if c >255 then c:=255;
               if c <0 then c:=0;
               imai8[y,x]:=round(c);
               datmini:=minvalue([c,datmini]);
               datmaxi:=maxvalue([c,datmaxi]);
               sum:=sum+c;
               sum2:=sum2+c*c;
               inc(ni);
            end else imai8[y,x]:=savi8[y,x];
          end;
        end;
        end;
   16 : begin
        max16:=high(smallint);
        min16:=low(smallint);
        for y:=m-1 to hi-m do begin
          for x:=m-1 to wi-m do begin
            if savi16[y,x]< filtertresh then begin
               c:=0;
               for i :=1 to n do
                 for j :=1 to n do
                   c:=c+a[j,i]*savi16[y-m+i,x-m+j];
               c:= c / k;
               if c >max16 then c:=max16;
               if c <min16 then c:=min16;
            end else c:=savi16[y,x];
            imai16[y,x]:=round(c);
            datmini:=minvalue([c,datmini]);
            datmaxi:=maxvalue([c,datmaxi]);
            sum:=sum+c;
            sum2:=sum2+c*c;
            inc(ni);
          end;
        end;
        end;
   32 : begin
        max32:=high(longint);
        min32:=low(longint);
        for y:=m-1 to hi-m do begin
          for x:=m-1 to wi-m do begin
            if savi32[y,x]< filtertresh then begin
               c:=0;
               for i :=1 to n do
                 for j :=1 to n do
                   c:=c+a[j,i]*savi32[y-m+i,x-m+j];
               c:= c / k;
               if c >max32 then c:=max32;
               if c <min32 then c:=min32;
               imai32[y,x]:=round(c);
               datmini:=minvalue([c,datmini]);
               datmaxi:=maxvalue([c,datmaxi]);
               sum:=sum+c;
               sum2:=sum2+c*c;
               inc(ni);
            end else imai32[y,x]:=savi32[y,x];
          end;
        end;
        end;
end;
end;
moyenne:=sum/ni;
sigma:=sqrt( (sum2/ni)-(moyenne*moyenne) );
SetRange;
Redraw;
end;

procedure LoadImage;
var ext : string;
    x,y : integer;
begin
with LoadAstroForm do begin
hi:=0;
la:=0;
naxis3:=1;
projfits:='-';
msg:='';
filename:='.tmp.';
ctype1:='' ;ctype2:='';
BMPcolor:=false;
if UseFlip then begin
   UseFlip:=false;
   invertX:=FlipX<0;
   invertY:=FlipY<0;
end else begin
   invertX:=false;
   invertY:=false;
end;
SpeedButton2.Down:=InvertY;
SpeedButton3.Down:=InvertX;
SetScale(true);
fi:=filelistbox1.filename;
ext:=lowercase(extractfileext(fi));
Screen.cursor:=crHourGlass;
try
setlength(imai8,1,1);
setlength(imai16,1,1);
setlength(imai32,1,1);
setlength(imar32,1,1);
setlength(imar64,1,1);
setlength(savi8,1,1);
setlength(savi16,1,1);
setlength(savi32,1,1);
setlength(savr32,1,1);
setlength(savr64,1,1);
if IsFitsExt(ext) then
   ReadFitsImage(fi,hi,wi,datmini,datmaxi);
if pos(ext,'.pic')>0 then
   ReadPICImage(fi,hi,wi,datmini,datmaxi);
if pos(ext,'.bmp .dib .gif .jif .jpg .jpeg .tga .rle .pcx')>0 then
   ReadBMPImage(fi,hi,wi,datmini,datmaxi);
if ((hi>0)and(wi>0)) then begin
case bitpix of
  -64 : begin
        setlength(savr64,hi,wi);
        for y:=0 to hi-1 do for x:=0 to wi-1 do savr64[y,x]:=imar64[y,x];
        end;
  -32 : begin
        setlength(savr32,hi,wi);
        for y:=0 to hi-1 do for x:=0 to wi-1 do savr32[y,x]:=imar32[y,x];
        end;
    8 : begin
        setlength(savi8,hi,wi);
        for y:=0 to hi-1 do for x:=0 to wi-1 do savi8[y,x]:=imai8[y,x];
        end;
   16 : begin
        setlength(savi16,hi,wi);
        for y:=0 to hi-1 do for x:=0 to wi-1 do savi16[y,x]:=imai16[y,x];
        end;
   32 : begin
        setlength(savi32,hi,wi);
        for y:=0 to hi-1 do for x:=0 to wi-1 do savi32[y,x]:=imai32[y,x];
        end;
end;
  label10.caption:='/'+trim(inttostr(naxis3));
  edit4.text:=trim(inttostr(curimage));
  SetRange;
  savmaxi:=datmaxi;
  savmini:=datmini;
  savmoyenne:=moyenne;
  savsigma:=sigma;
  x1:=0; x2:=wi; wa:=wi;
  y1:=0; y2:=hi; ha:=hi;
  ox1:=x1;ox2:=x2;oy1:=y1;oy2:=y2;
  if autofilter then begin
     edit5.text:=floattostrf((datmaxi-datmini)/2+datmini,ffgeneral,6,2);
     autofilter:=false;
     end;
  if combobox3.itemindex>0 then Filter
                           else Redraw;
  if projfits<>'-' then begin
    arref:=ar;
    deref:=de;
    rot:=rot1;
  end;
  ImageOK:=true;
end
else if not BMPcolor then BadImage;
finally
Screen.cursor:=crDefault;
autoload:=false;
autodisplay:=false;
end;
end;
end;

procedure TLoadAstroForm.FileListBox1Click(Sender: TObject);
begin
  curimage:=strtointdef(edit4.text,0);
  LoadImage;
end;

procedure TLoadAstroForm.FileListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  APoint: TPoint;
  Index: integer;
  fi,ext,buf : string;
  headerok : boolean;
begin
  if Button = mbRight then  begin
  msg:='';
  APoint.X := X;
  APoint.Y := Y;
  Index := FileListBox1.ItemAtPos(APoint, True);
  if index=-1 then exit;
  fi:=FileListBox1.Items.Strings[index];
  ext:=lowercase(extractfileext(fi));
  buf:=FileListBox1.Directory;
  if copy(buf,length(buf),1)<>'\' then buf:=buf+'\';
  fi:=buf+fi;
  if IsFitsExt(ext) then ShowFitsHeader(fi,headerok);
  if pos(ext,'.pic')>0 then ShowPICHeader(fi,headerok);
  if headerok then begin
    if bigimaform=nil then Application.CreateForm(TBigImaForm, BigImaForm);
    bigimaform.caption:=fi;
    bigimaform.memo1.visible:=true;
    bigimaform.image1.visible:=false;
    bigimaform.clientwidth:=bigimaform.Memo1.width+20;
    bigimaform.clientheight:=bigimaform.Memo1.height+20;
    bigimaform.showmodal;
    bigimaform.memo1.visible:=false;
    bigimaform.image1.visible:=true;
  end
  else Label2.Caption:=msg;
  end;
end;

procedure TLoadAstroForm.FormCreate(Sender: TObject);
var f : tsearchrec;
    rc,i,ii : integer;
    ext,name : string;
    l1,l2 : TstringList;
    pal : HPALETTE;
    ok: boolean;
    Registry1: TRegistry;
begin
//if CurrentDir='' then GetDir(0,currentdir);
InitString;
SetLang;
if debugon then writedebug('Load NViewLib DLL');
nviewlib := LoadLibrary('nviewlib.dll');
if nviewlib<>0 then begin
    NViewLibLoad:= TNViewLibLoad(GetProcAddress(nviewlib, 'NViewLibLoad'));
    nvlib:=true;
    if debugon then writedebug('NViewLib DLL found');
end else begin
    nvlib:=false;
    if debugon then writedebug('NViewLib DLL not found');
end;
naxis3:=1;
curimage:=1;
edit4.text:='0';
edit5.text:='9E99';
autoload:=false;
autodisplay:=false;
autofilter:=false;
skipreload:=false;
GetDir(0,currentdir);
if debugon then writedebug('Create image. dir='+currentdir);
filename:='.tmp.';
la:=0;
projfits:='-';
ImageOK:=false;
lockpalette:=true;
l1:=TstringList.create;
l2:=TstringList.create;
l1.sorted:=true;
l2.sorted:=true;
rc:=findfirst(CurrentDir+'\palettes\*.*',0,f);
while rc=0 do begin
   ext:=lowercase(extractfileext(f.name));
   name:=lowercase(copy(f.name,1,pos('.',f.name)-1));
   if ext='.lut' then begin
      l1.add(name);
   end;
   if ext='.itt' then begin
      l2.add(name);
   end;
   rc:=findnext(f);
end;
findclose(f);
if debugon then writedebug('Number of LUT : '+inttostr(l1.count));
if debugon then writedebug('Number of ITT : '+inttostr(l2.count));
ii:=0;
for i:=0 to l1.count-1 do begin
    name:=l1.strings[i];
    ComboBox1.items.add(name);
    if name='ramp' then ii:=i;
end;
ComboBox1.itemindex:=ii;
ii:=0;
for i:=0 to l2.count-1 do begin
    name:=l2.strings[i];
    ComboBox2.items.add(name);
    if name='4_ramp' then ii:=i;
end;
ComboBox2.itemindex:=ii;
Combobox3.itemindex:=0;
l1.free;
l2.free;
lockpalette:=false;
image1.height:=240;
image1.width:=3200;
imabmp:=Tbitmap.create;
imabmp.IgnorePalette:=false;
imabmp.pixelformat:=pf8bit;
scalebmp:=Tbitmap.create;
scalebmp.width:=256;
scalebmp.height:=1;
scalebmp.PixelFormat:=pf8Bit;
scalebmp.Ignorepalette:=false;
image1.canvas.stretchdraw(Rect(0,0,image1.Width,image1.Height),imabmp);
image1.height:=240;
image1.width:=320;
setITT;
crePalette(pal);
imabmp.Palette:=pal;
scalebmp.Palette:=pal;
image1.canvas.stretchdraw(Rect(0,0,image1.Width,image1.Height),imabmp);
image2.canvas.stretchdraw(Rect(0,0,image2.Width,image2.Height),scalebmp);
SetScale(false);
RadioGroup2.Enabled:=true;
ClearImage;
Registry1 := TRegistry.Create;
with Registry1 do begin
  ok:=Openkey('Software\Astro_PC\Ciel\Position',false);
  if ok then begin
     if ValueExists('Projfits') then begin
        name:=ReadString('Projfits')+'-';
        Projfits:=name[1];
     end;
     if ValueExists('FitsAR') then Loadastroimage.ar:=ReadFloat('FitsAR');
     if ValueExists('FitsDE') then Loadastroimage.de:=ReadFloat('FitsDE');
  end;
  CloseKey;
end;
Registry1.Free;
end;

procedure TLoadAstroForm.ScrollBar1Change(Sender: TObject);
var buf : string;
begin
if lockscroll then exit;
if scrollbar1.position=scrollbar2.position then scrollbar1.position:=scrollbar1.position+1;
dmini:=(scrollbar1.position-10000)*scrollscale;
str(dmini:8:1,buf); edit1.text:=trim(buf);
timer1.enabled:=false;
timer1.enabled:=true;
end;

procedure TLoadAstroForm.ScrollBar2Change(Sender: TObject);
var buf : string;
begin
if lockscroll then exit;
if scrollbar1.position=scrollbar2.position then scrollbar2.position:=scrollbar2.position-1;
dmaxi:=(scrollbar2.position-10000)*scrollscale;
str(dmaxi:8:1,buf); edit2.text:=trim(buf);
timer1.enabled:=false;
timer1.enabled:=true;
end;

procedure TLoadAstroForm.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var xx,yy : integer;
    zz : double;
    buf : string;
begin
if (not ImageOK) or bmpcolor then exit;
if (x<=0)or(x>=image1.Width)or(y<=0)or(y>=image1.Height) then exit;
if shift = [ssLeft] then begin
     if ZoomInit then Image1.Canvas.DrawFocusRect(Rect(Xz1,Yz1,Xz2,Yz2));
     Xz2:=x;Yz2:=y;
     ZoomInit:=True;
     Image1.Canvas.brush.color:=clWhite;
     Image1.Canvas.DrawFocusRect(Rect(Xz1,Yz1,Xz2,Yz2));
end;
if invertX then X:=image1.width-x;
if invertY then Y:=image1.height-y;
yy:=round(maxvalue([0,minvalue([hi-1,y1+wa*(y/image1.width)])]) );
xx:=round(maxvalue([0,minvalue([wi-1,x1+ha*(x/image1.height)])]) );
case bitpix of
-64 : zz:=bzero+bscale*imar64[yy,xx];
-32 : zz:=bzero+bscale*imar32[yy,xx];
  8 : zz:=bzero+bscale*imai8[yy,xx];
 16 : zz:=bzero+bscale*imai16[yy,xx];
 32 : zz:=bzero+bscale*imai32[yy,xx];
 else zz:=0;
end;
str(xx:5,buf);
label1.caption:='X: '+buf;
str(yy:5,buf);
label1.caption:=label1.caption+'   Y: '+buf;
buf:=floattostrF(zz,ffGeneral,12,0);
label1.caption:=label1.caption+'   I: '+buf;
end;

procedure TLoadAstroForm.SpeedButton2Click(Sender: TObject);
begin
InvertY:=not InvertY;
SpeedButton2.Down:=InvertY;
if imageOK then Redraw;
end;

procedure TLoadAstroForm.SpeedButton3Click(Sender: TObject);
begin
InvertX:=not InvertX;
SpeedButton3.Down:=InvertX;
if imageOK then Redraw;
end;

procedure TLoadAstroForm.ComboBox1Change(Sender: TObject);
begin
if lockpalette then exit;
Redraw;
end;

procedure TLoadAstroForm.ComboBox2Change(Sender: TObject);
begin
if lockpalette then exit;
SetITT;
Redraw;
end;

procedure TLoadAstroForm.SpeedButton4Click(Sender: TObject);
begin
if not ImageOK then exit;
x1:=0; x2:=wi;
y1:=0; y2:=hi;
wa:=x2-x1;
ha:=y2-y1;
ReDraw;
end;

procedure TLoadAstroForm.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var xx1,xx2,yy1,yy2 : integer;
begin
if not ImageOk then exit;
case Button of
mbLeft : begin
   if ZoomInit then begin
     Image1.Canvas.DrawFocusRect(Rect(Xz1,Yz1,Xz2,Yz2));
     ZoomInit:=False;
     if (X>=Xz1) and (X<=Xz2) and (Y>=Yz1) and (Y<=Yz2)
        and (Xz1<>Xz2 ) and (Yz1<>Yz2) then begin
            if invertX then begin
                            Xz2:=image1.width-xz2;
                            Xz1:=image1.width-xz1;
                            end;
            if invertY then begin
                            Yz2:=image1.height-yz2;
                            Yz1:=image1.height-yz1;
                            end;
            if invertX or InvertY then begin
               xx1:=trunc(minvalue([xz1,xz2]));
               xx2:=trunc(maxvalue([xz1,xz2]));
               yy1:=trunc(minvalue([yz1,yz2]));
               yy2:=trunc(maxvalue([yz1,yz2]));
               xz1:=xx1;
               xz2:=xx2;
               yz1:=yy1;
               yz2:=yy2;
            end;
            xx1:=round(x1+ha*(xz1/image1.height));
            xx2:=round(x1+ha*(xz2/image1.height));
            yy1:=round(y1+wa*(yz1/image1.width));
            yy2:=round(y1+wa*(yz2/image1.width));
            ox1:=x1;ox2:=x2;oy1:=y1;oy2:=y2;
            x1:=Xx1;
            x2:=Xx2;
            y1:=Yy1;
            y2:=Yy2;
            wa:=x2-x1;
            ha:=y2-y1;
            if wa<30 then begin
              x1:=x1-(30-wa) div 2;
              x2:=x1+30;
              wa:=30;
            end;
            if ha<30 then begin
              y1:=y1-(30-ha) div 2;
              y2:=y1+30;
              ha:=30;
            end;   
            ReDraw;
     end;
   end;
   Xz1:=X;
   Yz1:=Y;
 end;
end;
end;

procedure TLoadAstroForm.SpeedButton5Click(Sender: TObject);
begin
if not ImageOK then exit;
x1:=ox1;
x2:=ox2;
y1:=oy1;
y2:=oy2;
wa:=x2-x1;
ha:=y2-y1;
ReDraw;
end;


procedure TLoadAstroForm.Timer1Timer(Sender: TObject);
begin
timer1.enabled:=false;
if not ImageOK then exit;
Redraw;
end;

procedure TLoadAstroForm.BitBtn1Click(Sender: TObject);
begin
if savepicturedialog1.execute then
   imabmp.SaveToFile(savepicturedialog1.filename);
end;

procedure TLoadAstroForm.SpeedButton1Click(Sender: TObject);
begin
if bigimaform=nil then Application.CreateForm(TBigImaForm, BigImaForm);
bigimaform.memo1.visible:=false;
bigimaform.image1.visible:=true;
BigImaform.Caption:=Label2.Caption;
BigImaForm.Width:=trunc(minvalue([Screen.Width,ImaBmp.Width+20]));
BigImaForm.Height:=trunc(minvalue([Screen.Height,ImaBmp.Height+40]));
BigImaForm.Image1.Picture.Bitmap.Assign(ImaBmp);
BigImaForm.Position:=poDesktopCenter;
BigImaForm.ShowModal;
end;

Procedure ChgScale;
begin
lockscroll:=true;
with Loadastroform do begin
dmini:=strtofloat(edit1.text);
scrollbar1.position:=round(dmini/scrollscale)+10000;
dmaxi:=strtofloat(edit2.text);
scrollbar2.position:=round(dmaxi/scrollscale)+10000;
end;
lockscroll:=false;
Redraw;
end;

procedure TLoadAstroForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if ord(key)<>13 then exit;
if not ImageOK then exit;
ChgScale;
end;

procedure TLoadAstroForm.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
if ord(key)<>13 then exit;
if not ImageOK then exit;
ChgScale;
end;

procedure TLoadAstroForm.SystemTreeView1Change(Sender: TObject;
  Node: TTreeNode);
begin
FilelistBox1.Directory:=SystemTreeView1.Directory;
end;

procedure TLoadAstroForm.RadioGroup2Click(Sender: TObject);
var lowfactor,higfactor : double;
begin
if not ImageOK then exit;
case radiogroup2.ItemIndex of
0 : begin
    dmini:=hdmin;
    dmaxi:=hdmax;
    scrollbar1.position:=round(hdmin/scrollscale)+10000;
    scrollbar2.position:=round(hdmax/scrollscale)+10000;
    end;
1 : begin
    dmini:=datmini;
    dmaxi:=datmaxi;
    scrollbar1.position:=round(datmini/scrollscale)+10000;
    scrollbar2.position:=round(datmaxi/scrollscale)+10000;
    end;
2 : begin  // 1 sigma asymetrique
    lowfactor:=2*(moyenne-datmini)/(datmaxi-datmini);
    higfactor:=2*(datmaxi-moyenne)/(datmaxi-datmini);
    dmini:=maxvalue([datmini,moyenne-sigma*lowfactor]);
    scrollbar1.position:=round(dmini/scrollscale)+10000;
    dmaxi:=minvalue([datmaxi,moyenne+sigma*higfactor]);
    scrollbar2.position:=round(dmaxi/scrollscale)+10000;
    end;
3 : begin  // 2 sigma asymetrique
    lowfactor:=2*(moyenne-datmini)/(datmaxi-datmini);
    higfactor:=2*(datmaxi-moyenne)/(datmaxi-datmini);
    dmini:=maxvalue([datmini,moyenne-2*sigma*lowfactor]);
    scrollbar1.position:=round(dmini/scrollscale)+10000;
    dmaxi:=minvalue([datmaxi,moyenne+2*sigma*higfactor]);
    scrollbar2.position:=round(dmaxi/scrollscale)+10000;
    end;
4 : begin  // 70% data asymetrique
    dmini:=datmini+0.3*(moyenne-datmini);
    dmaxi:=datmaxi-0.3*(datmaxi-moyenne);
    scrollbar1.position:=round(dmini/scrollscale)+10000;
    scrollbar2.position:=round(dmaxi/scrollscale)+10000;
    end;
end;
end;

procedure TLoadAstroForm.FormShow(Sender: TObject);
begin
if autoload then LoadImage
            else skipreload:=false;
end;

procedure TLoadAstroForm.SpeedButton6Click(Sender: TObject);
begin
invertX:=false;
invertY:=false;
SpeedButton2.Down:=InvertY;
SpeedButton3.Down:=InvertX;
if not imageok then exit;
if projfits<>'-' then begin
   if rotaok and (cdelt1>0) then invertX:=true;
   if rotaok and (cdelt2<0) then invertY:=true;
end;
SpeedButton2.Down:=InvertY;
SpeedButton3.Down:=InvertX;
Redraw;
end;

procedure TLoadAstroForm.Edit4Change(Sender: TObject);
begin
if (not ImageOK)or(skipreload) then begin skipreload:=false; exit; end;
  curimage:=strtointdef(edit4.text,0);
  LoadImage;
end;

procedure TLoadAstroForm.SpeedButton8Click(Sender: TObject);
var x,y : integer;
begin
Screen.cursor:=crHourGlass;
case bitpix of
  -64 : begin
        for y:=0 to hi-1 do for x:=0 to wi-1 do imar64[y,x]:=savr64[y,x];
        end;
  -32 : begin
        for y:=0 to hi-1 do for x:=0 to wi-1 do imar32[y,x]:=savr32[y,x];
        end;
    8 : begin
        for y:=0 to hi-1 do for x:=0 to wi-1 do imai8[y,x]:=savi8[y,x];
        end;
   16 : begin
        for y:=0 to hi-1 do for x:=0 to wi-1 do imai16[y,x]:=savi16[y,x];
        end;
   32 : begin
        for y:=0 to hi-1 do for x:=0 to wi-1 do imai32[y,x]:=savi32[y,x];
        end;
end;
datmaxi:=savmaxi;
datmini:=savmini;
moyenne:=savmoyenne;
sigma:=savsigma;
SetRange;
Screen.cursor:=crDefault;
Redraw;
end;

procedure TLoadAstroForm.SpeedButton7Click(Sender: TObject);
begin;
Screen.cursor:=crHourGlass;
Filter;
Screen.cursor:=crDefault;
end;

procedure TLoadAstroForm.BitBtn2Click(Sender: TObject);
begin
showhelp('doc3.html#image');
end;

end.

