unit Orbites;

interface

uses SkyLib,Math,planet1,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

procedure Init;
procedure LoadComete;
Procedure LoadAsteroide;
PROCEDURE InitComete( n : Integer ; var CometeName : String);
PROCEDURE Comete(jd :Double; VAR ar,de,dist,r,elong,phase,magn,diam,lc,car,cde : Double);
Procedure ReadAsteroide(ncat,n : integer; var name,annee,at,am,oomi,oma,i,oe,Aa,Ah,Ag : string);
PROCEDURE InitAsteroide(n : integer ; var AsterName : String );
PROCEDURE Asteroide(jd :Double; VAR ar,de,dist,r,elong,phase,magn : Double);
procedure OpenAstorb(fn : string; var yy : integer);
procedure CloseAstorb;

var
  ComFile,AstFile : TstringList;
  PlanetPath : string;
  AsteroidCat,MaxAstor,MinAstor : integer;
implementation

const  tlight : double = 5.77551831e-3;

VAR Oaa,Obb,Occ,Oa,Ob,Oc,Ot,Oq,Oe,Oomi,Oepoque
    ,Omk1,Omk2 :Double;     (* parametres de l'orbite   *)
  At,Am,Aa,Ah,Ag : double;
  annee,OldCat : integer;
  fAstorb : TextFile;

PROCEDURE Kepler(VAR E1:Double; e,m:Double);
 VAR e0,c:Double;
 BEGIN
{ meeus  22.3 }
    e0:=radtodeg(e);
    E1:=m;
    REPEAT
      c := (m+e0*sin(degtorad(E1)) - E1) / (1.0 - e*cos(degtorad(E1))) ;
      E1:= E1 + c ;
    UNTIL ABS(c) < 1.0E-9 ;
 END ;

Procedure RectToPol(x,y : double; var r,alpha : double);
begin
r:=sqrt(x*x+y*y);
alpha:=radtodeg(arctan2(y,x));
end;

Procedure PrecessElem(annee : integer; var i,oomi,oma : double);
var t,tau0,tau,eta,theta,theta0,i0,oma0,x,y,r,alpha,cosi : double;
const final = 2000.0;
begin
tau0:=(annee-1900)/1000;    { meeus 17. }
tau:=(final-1900)/1000;
t := tau-tau0;
eta := ((471.07-6.75*tau0+0.57*tau0*tau0)*t+(-3.37+0.57*tau0)*t*t+0.05*t*t*t)/3600;
theta0:=173.950833+(32869*tau0+56*tau0*tau0-(8694+55*tau0)*t+3*t*t)/3600;
theta:=theta0+((50256.41+222.29*tau0+0.26*tau0*tau0)*t+(111.15+0.26*tau0)*t*t+0.1*t*t*t)/3600;
i0:=degtorad(i); oma0:=degtorad(oma);
eta:=degtorad(eta); theta:=degtorad(theta); theta0:=degtorad(theta0);
cosi:=cos(i0)*cos(eta)+sin(i0)*sin(eta)*cos(oma0-theta0);
y:=sin(i0)*sin(oma0-theta0);        { meeus 17.2 }
x:=-sin(eta)*cos(i0)+cos(eta)*sin(i0)*cos(oma0-theta0);
RectToPol(x,y,r,alpha);
i:=radtodeg(arcsin(r));
if cosi<0 then i:=180-i ;
oma:=alpha+radtodeg(theta);
y:=-sin(eta)*sin(oma0-theta0);      { meeus 17.3 }
x:=sin(i0)*cos(eta)-cos(i0)*sin(eta)*cos(oma0-theta0);
RectToPol(x,y,r,alpha);
oomi:=oomi+alpha;
end;

PROCEDURE InitComete(n : integer ; var CometeName : String );
VAR  buf,val : String;
  i,Oma,ff,g,h,p,qq,r,ooe : Double;
BEGIN
buf := ComFile.Strings[n];
CometeName:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
Annee:=strtoint(val) ;
val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
Ot:=jd(strtoint(copy(val,1,4)),strtoint(copy(val,5,2)),
       strtoint(copy(val,7,2)),strtofloat('0'+copy(val,9,length(val)))*24) ;
val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
Oq:=strtofloat(val) ;
val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
Oe:=strtofloat(val) ;
val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
Oomi:=strtofloat(val) ;
val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
Oma:=strtofloat(val) ;
val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
i:=strtofloat(val)  ;
val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
Omk1:=strtofloat(val) ;
val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
Omk2:=strtofloat(val) ;
val:=buf;
if Annee<>2000 then PrecessElem(Annee,i,oomi,oma);
Oepoque:=jd(Annee,1,1,0);
{t := (Oepoque-2415020.0)/36525.0 ; { meeus 18.1 }
{ooe := 23.452294 +(- 1.30125E-2 +(-1.64E-6+5.03E-7*t)*t)*t ; meeus 18.4 }
ooe := 23.43929111; {meeus91 32.7}
ff:= cos(degtorad(Oma));  { meus 25.13 }
g := sin(degtorad(Oma)) * cos(degtorad(ooe));
h := sin(degtorad(Oma)) * sin(degtorad(ooe));
p := -sin(degtorad(Oma)) * cos(degtorad(i));
qq:= cos(degtorad(Oma))*cos(degtorad(i))*cos(degtorad(ooe))-sin(degtorad(i))*sin(degtorad(ooe));
r := cos(degtorad(Oma))*cos(degtorad(i))*sin(degtorad(ooe))+sin(degtorad(i))*cos(degtorad(ooe));
Oaa := radtodeg(arctan2(ff,p)) ;
Obb := radtodeg(arctan2(g,qq));
Occ := radtodeg(arctan2(h,r)) ;
Oa := sqrt(ff*ff+p*p);
Ob := sqrt(g*g+qq*qq);
Oc := sqrt(h*h+r*r) ;
END  ;

PROCEDURE OrbRect(jd :Double ; VAR xc,yc,zc,rs :Double );
  VAR nu :Double ;

procedure eliptique ;
  VAR da,n0,m,ex,num,den :Double ;
   begin
     da:=Oq/(1.0-Oe);                     { meeus 25.12 }
     n0:=0.9856076686/(da*sqrt(da));
     m:=n0*(jd-Ot);
     Kepler(ex,Oe,m) ;
     num:=sqrt(1.0+Oe)*tan(degtorad(ex)/2.0);  { meeus 25.1 }
     den:=sqrt(1.0-Oe);
     nu:=2.0*radtodeg(arctan2(num,den));
     rs:=da*(1.0-Oe*cos(degtorad(ex)));   { meeus 25.2 }
  END;

procedure parabolique ;
  VAR w,s1,s :Double ;
   begin
      w :=3.64911624E-2*(jd-Ot)/(Oq*sqrt(Oq));  { meeus 26.1 }
      s1 := 0.0;
      REPEAT                                    { meeus 26.4 }
        s:=s1;
        s1:=(2.0*s*s*s+w)/(3.0*(s*s+1.0));
      UNTIL ABS(s1-s)<1.0E-9 ;
      s:=s1;
      nu:=2.0*radtodeg(arctan(s)) ;       { meeus 26.2 }
      rs:=Oq*(1.0+s*s) ;
   end;

procedure hyperbolique ;
  VAR da,n0,m,U,U0,num,den :Double;
begin
    da:=Oq/abs(1.0-Oe);
    n0:=0.01720209895/(da*sqrt(da));
    m:=n0*(jd-Ot);
    U:=0.5 ;
    Repeat
      U0:=U ;
      U:=(2*U0*(Oe-U0*(1-m-ln(abs(U0)))))/(Oe*(U0*U0+1)-2*U0);
    until abs(U-U0) < 1E-9 ;
    num:=sqrt(Oe*Oe-1)*(U*U-1)/(2*U) ;
    den:=Oe-(U*U+1)/(2*U) ;
    nu:=radtodeg(arctan2(num,den));
    rs:=da*((Oe*(U*U+1)/(2*U))-1) ;
end ;

BEGIN
  if oe<1 then eliptique ;
  if oe=1 then parabolique;
  if oe>1 then hyperbolique;
  xc:=rs*Oa*sin(degtorad((Oaa+Oomi+nu))); { meeus 25.14 }
  yc:=rs*Ob*sin(degtorad((Obb+Oomi+nu)));
  zc:=rs*Oc*sin(degtorad((Occ+Oomi+nu)));
END ;

PROCEDURE Comete(jd :Double; VAR ar,de,dist,r,elong,phase,magn,diam,lc,car,cde : Double);
VAR xc,yc,zc,xs,ys,zs,rr,dc,cxc,cyc,czc :Double;
    ierr : integer;
BEGIN
SolRect(jd,false,xs,ys,zs,ierr);
OrbRect(jd,xc,yc,zc,r);
dist:=sqrt((xc+xs)*(xc+xs)+(yc+ys)*(ys+yc)+(zc+zs)*(zc+zs));
jd:=jd-dist*tlight;
OrbRect(jd,xc,yc,zc,r);
dist:=sqrt((xc+xs)*(xc+xs)+(yc+ys)*(ys+yc)+(zc+zs)*(zc+zs));
ar:=radtodeg(arctan2((ys+yc),(xs+xc))) ;   { meeus 25.15 }
ar:=Rmod(ar+360.0,360.0)/15;
de:=radtodeg(arcsin((zc+zs)/dist));
rr:=sqrt(xs*xs+ys*ys+zs*zs);
elong:=radtodeg(arccos((rr*rr+dist*dist-r*r)/(2.0*rr*dist)));
phase:=radtodeg(arccos((r*r+dist*dist-rr*rr)/(2.0*r*dist)));
magn:=Omk1+5.0*log10(dist)+Omk2*log10(r);  { meeus 25.16 }
{ diametre de la chevelure en minutes }
diam:=(maxvalue([0,1-ln(r)])/maxvalue([1,omk1-2]))*30/dist;
{ longueur de la queue en UA }
Lc:= maxvalue([0,1-ln(r)])/power(maxvalue([1,omk1]),1.5);
cxc:=xc+Lc*xc/r;
cyc:=yc+Lc*yc/r;
czc:=zc+Lc*zc/r;
car:=radtodeg(arctan2((ys+cyc),(xs+cxc))) ;
car:=Rmod(car+360.0,360.0)/15;
dc:=sqrt((cxc+xs)*(cxc+xs)+(cyc+ys)*(ys+cyc)+(czc+zs)*(czc+zs));
cde:=radtodeg(arcsin((czc+zs)/dc));
END ;

Procedure ReadAsteroide(ncat,n : integer; var name,annee,at,am,oomi,oma,i,oe,Aa,Ah,Ag : string);
var buf,val : string;
begin
case ncat of
0 : begin    // asteroides.dat
    buf := AstFile.Strings[n];
    Name:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    val:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    At:=copy(val,1,4)+copy(val,6,2)+copy(val,9,2);
    oe:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    Aa:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    i:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    oma:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    oomi:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    Annee:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    am:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    ah:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    ag:=copy(buf,1,pos('|',buf)-1);delete(buf,1,pos('|',buf));
    end;
1 : begin    // astorb
    buf := AstFile.Strings[n];
    Name:=copy(buf,1,23); // en fait 24, ! calcul de masse !
    Annee:='2000' ;
    at := copy(buf,106,8);
    Am:=copy(buf,115,10) ;
    Oomi:=copy(buf,126,10) ;
    Oma:=copy(buf,137,10) ;
    i:=copy(buf,148,9)  ;
    Oe:=copy(buf,158,10) ;
    Aa:=copy(buf,169,12) ;
    Ah:=copy(buf,42,5) ;
    Ag:=copy(buf,48,5) ;
    end;
2 : begin   // calcul de masse
{    System.seek(fAstorb,n-1);}
    if eof(fastorb) then begin Name:=' '; exit; end;
    Readln(fAstorb,buf);
    Name:=copy(buf,1,23);
    Annee:='2000' ;
    at := copy(buf,106,8);
    Am:=copy(buf,115,10) ;
    Oomi:=copy(buf,126,10) ;
    Oma:=copy(buf,137,10) ;
    i:=copy(buf,148,9)  ;
    Oe:=copy(buf,158,10) ;
    Aa:=copy(buf,169,12) ;
    Ah:=copy(buf,42,5) ;
    Ag:=copy(buf,48,5) ;
    end;
end;
end;

PROCEDURE InitAsteroide(n : integer ; var AsterName : String );
VAR
   v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11 : string;
   i,Oma,ff,g,h,p,qq,r,ooe : Double;
BEGIN
ReadAsteroide(AsteroidCat,n,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11);
AsterName:=v1;
if AsterName=' ' then begin exit; end;
Annee:=strtoint(v2) ;
At:=jd(strtoint(copy(v3,1,4)),strtoint(copy(v3,5,2)),
       strtoint(copy(v3,7,2)),0) ;
Am:=strtofloat(v4) ;
Oomi:=strtofloat(v5) ;
Oma:=strtofloat(v6) ;
i:=strtofloat(v7)  ;
Oe:=strtofloat(v8) ;
Aa:=strtofloat(v9) ;
Ah:=strtofloat(v10) ;
Ag:=strtofloat(v11) ;
if Annee<>2000 then PrecessElem(Annee,i,oomi,oma);
Oepoque:=jd(Annee,1,1,0);
{t := (Oepoque-2415020.0)/36525.0 ; { meeus 18.1 }
{ooe := 23.452294 +(- 1.30125E-2 +(-1.64E-6+5.03E-7*t)*t)*t ; {meeus 18.4 }
ooe := 23.43929111; {j2000 meeus91 32.7}
ff:= cos(degtorad(Oma));  { meus 25.13 }
g := sin(degtorad(Oma)) * cos(degtorad(ooe));
h := sin(degtorad(Oma)) * sin(degtorad(ooe));
p := -sin(degtorad(Oma)) * cos(degtorad(i));
qq:= cos(degtorad(Oma))*cos(degtorad(i))*cos(degtorad(ooe))-sin(degtorad(i))*sin(degtorad(ooe));
r := cos(degtorad(Oma))*cos(degtorad(i))*sin(degtorad(ooe))+sin(degtorad(i))*cos(degtorad(ooe));
Oaa := radtodeg(arctan2(ff,p)) ;
Obb := radtodeg(arctan2(g,qq));
Occ := radtodeg(arctan2(h,r)) ;
Oa := sqrt(ff*ff+p*p);
Ob := sqrt(g*g+qq*qq);
Oc := sqrt(h*h+r*r) ;
END  ;

PROCEDURE Asteroide(jd :Double; VAR ar,de,dist,r,elong,phase,magn : Double);
VAR xc,yc,zc,xs,ys,zs,rr,phi1,phi2 :Double;
    nu,da,n0,m,ex,num,den :Double ;
    ierr : integer;

Procedure AstGeom ;
begin
m:=rmod(am+n0*(jd-At),360);
Kepler(ex,Oe,m) ;
num:=sqrt(1.0+Oe)*tan(degtorad(ex)/2.0);  { meeus 25.1 }
den:=sqrt(1.0-Oe);
nu:=2.0*radtodeg(arctan2(num,den));
r:=da*(1.0-Oe*cos(degtorad(ex)));   { meeus 25.2 }
xc:=r*Oa*sin(degtorad((Oaa+Oomi+nu))); { meeus 25.14 }
yc:=r*Ob*sin(degtorad((Obb+Oomi+nu)));
zc:=r*Oc*sin(degtorad((Occ+Oomi+nu)));
dist:=sqrt((xc+xs)*(xc+xs)+(yc+ys)*(ys+yc)+(zc+zs)*(zc+zs));
end;

BEGIN
da:=Aa ;                     { meeus 25.12 }
n0:=0.9856076686/(da*sqrt(da));
SolRect(jd,false,xs,ys,zs,ierr);
AstGeom;
jd:=jd-dist*tlight;
AstGeom;
ar:=radtodeg(arctan2((ys+yc),(xs+xc))) ;   { meeus 25.15 }
ar:=Rmod(ar+360.0,360.0)/15;
de:=radtodeg(arcsin((zc+zs)/dist));
rr:=sqrt(xs*xs+ys*ys+zs*zs);
elong:=radtodeg(arccos((rr*rr+dist*dist-r*r)/(2.0*rr*dist)));
phase:=(arccos((r*r+dist*dist-rr*rr)/(2.0*r*dist)));
phi1:=exp(-3.33*power(tan(phase/2),0.63));  { meeus91 32.14 }
phi2:=exp(-1.87*power(tan(phase/2),1.22));
magn:=Ah+5.0*log10(dist*r)-2.5*log10((1-Ag)*phi1+Ag*phi2);
phase:=radtodeg(phase);
end ;

procedure LoadComete ;
var
    buf,fn : string;
    f : TextFile;
begin
if debugon then writedebug('Read comets file');
try
ComFile.Clear;
fn:=planetpath+'\COMETES.DAT';
if FileExists(fn) then begin
{ComFile.LoadFromFile(planetpath+'\COMETES.DAT');}
  if debugon then writedebug('Assignfile '+fn);
  AssignFile(f,fn);
  FileMode:=0;
  if debugon then writedebug('Reset file '+fn);
  reset(f);
  ComFile.beginupdate;
  repeat
    Readln(f,buf);
    if trim(buf)>'' then ComFile.Add(buf);
  until eof(f);
  ComFile.endupdate;
  if debugon then writedebug('Close file '+fn);
  CloseFile(f);
end;
finally
if ComFile.Count=0 then begin
  if debugon then writedebug('Empty comet list');
  comfile.add(' ');
end;
end;
end;

procedure LoadAsteroide;
var i : integer;
    buf : string;
    f : TextFile;
begin
if debugon then writedebug('Read asteroids file '+inttostr(asteroidcat));
try
AstFile.Clear;
case AsteroidCat of
0 : if FileExists(planetpath+'\ASTEROIDES.DAT') then begin
  if debugon then writedebug('Assignfile '+planetpath+'\ASTEROIDES.DAT');
  AssignFile(f,planetpath+'\ASTEROIDES.DAT');
  FileMode:=0;
  if debugon then writedebug('Reset file');
  reset(f);
  for i:=1 to MaxAstor do begin
    Readln(f,buf);
    if trim(buf)>'' then AstFile.Add(buf);
    if eof(f) then break;
  end;
  if debugon then writedebug('Close file');
  CloseFile(f);
  end;
1 : if FileExists(planetpath+'\ASTORB.DAT') then begin
  if debugon then writedebug('Assignfile '+planetpath+'\ASTORB.DAT');
  AssignFile(f,planetpath+'\ASTORB.DAT');
  FileMode:=0;
  if debugon then writedebug('Reset file');
  reset(f);
  Astfile.beginupdate;
  for i:=1 to MinAstor+MaxAstor do begin
    Readln(f,buf);
    if (i>=MinAstor)and(trim(buf)>'') then AstFile.Add(buf);
    if eof(f) then break;
  end;
  Astfile.endupdate;
  if debugon then writedebug('Close file');
  CloseFile(f);
  end;
end;
finally
if AstFile.Count=0 then begin
  if debugon then writedebug('Empty asteroid list');
  astfile.add(' ');
end;
end;
end;

procedure Init;
begin
if debugon then writedebug('Create ComFile');
ComFile := TStringList.Create;
ComFile.sorted:=true;
LoadComete;
if debugon then writedebug('Create AstFile');
AstFile := TStringList.Create;
AstFile.sorted:=false;
LoadAsteroide;
end;

procedure OpenAstorb(fn : string; var yy : integer);
var buf : string;
    i : integer;
begin
OldCat:=AsteroidCat;
AsteroidCat:=2;
AssignFile(fastorb,fn);
FileMode:=0;
reset(fastorb);
Readln(fAstorb,buf);
buf := copy(buf,106,4);
val(buf,yy,i);
if i>0 then yy:=0;
reset(fastorb);
end;

procedure CloseAstorb;
begin
AsteroidCat:=OldCat;
CloseFile(fastorb);
end;

end.
 