unit ShowFile;

interface

uses
  Printers,Math,SkyLib,Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, RxRichEd, ExtCtrls;

Procedure SetLang;

type
  TShowFileForm = class(TForm)
    SaveDialog1: TSaveDialog;
    RichEdit1: TRxRichEdit;
    Panel1: TPanel;
    BitBtn2: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn3: TBitBtn;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    BitBtn6: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RichEdit1DblClick(Sender: TObject);
    procedure RichEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure BitBtn6Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  ShowFileForm: TShowFileForm;
implementation

uses sky_p1;

{$R *.DFM}
Var Findpos : integer;
    appmsg : array[1..2] of string;

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
    i : integer;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='List';
with ShowfileForm do
  with inifile do begin
    Caption:=ReadString(section,'title',deftxt);
    BitBtn1.Caption:=ReadString('buttons','close',deftxt);
    BitBtn2.Caption:=ReadString('buttons','print',deftxt);
    BitBtn3.Caption:=ReadString(section,'t_1',deftxt);
    BitBtn4.Caption:=ReadString(section,'t_2',deftxt);
    BitBtn5.Caption:=ReadString(section,'t_3',deftxt);
    BitBtn6.Caption:=ReadString('main','t_22',deftxt);
    for i:=1 to 2 do begin
       appmsg[i]:=ReadString(section,'m_'+trim(inttostr(i)),deftxt);
    end;

  end;
inifile.free;
end;
end;

Procedure InitString;
begin
appmsg[1]:='non trouv dans la liste';
end;

procedure TShowFileForm.BitBtn1Click(Sender: TObject);
begin
ModalResult:=mrCancel;
Close;
end;

procedure TShowFileForm.FormShow(Sender: TObject);
begin
FindPos:=0;
RichEdit1.SelStart:=0;
RichEdit1.SelLength:=0;
richedit1.height:=height-80;
richedit1.width:=width-30;
end;

procedure TShowFileForm.BitBtn2Click(Sender: TObject);
begin
Printer.Orientation:=poPortrait;
RichEdit1.Print(' ');
end;

procedure TShowFileForm.BitBtn3Click(Sender: TObject);
var lt,i : integer;
begin
lt := length(edit1.text);
RichEdit1.Setfocus;
for i:=1 to 2 do begin
findpos:=Richedit1.Findtext(Edit1.text,findpos,richedit1.gettextlen,[]);
if findpos>0 then begin
   RichEdit1.SelStart:=findpos;
   RichEdit1.SelLength:=lt;
   findpos:=findpos+lt;
   break;
   end
else begin
   findpos:=0;
   RichEdit1.SelStart:=0;
   RichEdit1.SelLength:=0;
end;
end;
if findpos=0 then Showmessage(edit1.text+' '+appmsg[1]);
end;

procedure TShowFileForm.BitBtn4Click(Sender: TObject);
var tempstr : TstringList;
    temp,h1,h2,h3,h4,t1,t2 : string;
    i,n:integer;
begin
Tempstr := TStringList.Create;
try
Screen.Cursor:=crHourglass;
n:= Richedit1.lines.count-1;
h1:= richedit1.lines[0];
h2:= richedit1.lines[1];
h3:= richedit1.lines[2];
h4:= richedit1.lines[3];
t1:= richedit1.lines[n-1];
t2:= richedit1.lines[n];
tempstr.sorted:=true;
tempstr.beginupdate;
for i:=4 to n-2 do begin
    temp:= richedit1.lines[i];
    tempstr.add(temp);
end;
tempstr.endupdate;
n:=tempstr.count-1;
Richedit1.Clear;
//Richedit1.lines.beginupdate;
Richedit1.lines.add(h1);
Richedit1.lines.add(h2);
Richedit1.lines.add(h3);
Richedit1.lines.add(h4);
for i:=0 to n do begin
    temp:=tempstr[i];
    Richedit1.lines.add(temp);
end;
Richedit1.lines.add(t1);
Richedit1.lines.add(t2);
//Richedit1.lines.endupdate;
finally
tempstr.free;
screen.cursor:=crDefault;
end;
end;

Procedure SaveAstrometrica;
var buf,outl,mag : string;
    f : textfile;
    n,i,j : integer;
begin
with ShowFileForm do begin
AssignFile(f,savedialog1.Filename);
try
rewrite(f);
n:= Richedit1.lines.count-1;
for i:=3 to n-2 do begin
    buf:= richedit1.lines[i];
    outl:=trim(words(copy(buf,35,13),'',1,3));
    outl:=copy(outl+'             ',1,13)+'   ';
    outl:=outl+copy(buf,5,2)+' '+copy(buf,8,2)+' '+copy(buf,11,5)+' ';
    outl:=outl+copy(buf,18,3)+' '+copy(buf,22,2)+' '+copy(buf,25,4)+' ';
    if trim(outl)='' then continue;
    mag:='';
    j:=pos('mB:',buf);if j>0 then mag:=copy(buf,j+3,5);
    j:=pos('mr:',buf);if j>0 then mag:=copy(buf,j+3,5);
    j:=pos(' m:',buf);if j>0 then mag:=copy(buf,j+3,5);
    j:=pos('Vt:',buf);if j>0 then mag:=copy(buf,j+3,5);
    j:=pos('mV:',buf);if j>0 then mag:=copy(buf,j+3,5);
    j:=pos(' V:',buf);if j>0 then mag:=copy(buf,j+3,5);
    if trim(mag)='' then continue;
    outl:=outl+mag;
    Writeln(f,outl);
end;
finally
CloseFile(f);
end;
end;
end;

procedure TShowFileForm.BitBtn5Click(Sender: TObject);
var  currentdir : string;
begin
GetDir(0,currentdir);
try
   if SaveDialog1.Execute then
      if ExtractFileExt(savedialog1.Filename)='.cat' then SaveAstrometrica
         else Richedit1.Lines.SavetoFile(savedialog1.Filename);
finally
   ChDir(currentdir);
end;
end;

procedure TShowFileForm.FormCreate(Sender: TObject);
begin
//SendMessage(RichEdit1.Handle, EM_EXLIMITTEXT, 0, $7FFFFFFF);
InitString;
SetLang;
top:=0; left:=0;
//height:=trunc(minvalue([screen.height,600]));
//width:=trunc(minvalue([screen.width,900]));
end;

procedure TShowFileForm.RichEdit1DblClick(Sender: TObject);
var linnum,x,y : integer;
    x1,y1 : double;
    buf,s : string;
begin
linnum:=richedit1.CaretPos.y;
buf:=richedit1.Lines[linnum];
if (copy(buf,7,1)='h')and(copy(buf,10,1)='m') then begin
   sky_p1.FindAR:=strtofloat(copy(buf,5,2))+strtofloat(copy(buf,8,2))/60+strtofloat(copy(buf,11,5))/3600;
   s:=copy(buf,18,1);
   sky_p1.FindDE:=strtofloat(s+copy(buf,19,2))+strtofloat(s+copy(buf,21+length(ldeg),2))/60+strtofloat(s+copy(buf,23+length(ldeg)+length(lmin),4))/3600;
   sky_p1.FindDesc:=copy(buf,4,9999);
   projection(sky_p1.FindAR*15,sky_p1.FindDE,x1,y1,false) ;
   WindowXY(x1,y1,x,y);
   sky_p1.Identification(x,y,4);
end;
end;

procedure TShowFileForm.RichEdit1KeyPress(Sender: TObject; var Key: Char);
begin
if key=#27 then close;
end;

procedure TShowFileForm.BitBtn6Click(Sender: TObject);
begin
RichEdit1.SelectAll;
RichEdit1.CopyToClipboard;
end;

procedure TShowFileForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
if sky_p1.recordingmode then sky_p1.setrecording;
end;

end.
