unit Sky_Scale;

interface

uses Sky_Tstars,Math,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TScale = class(TForm)
    PaintBox1: TPaintBox;
    procedure FormPaint(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Scale: TScale;
  StarSize,StarDyn,maxma : Integer;
  Min_ma : double;
  StarColor : StarColArray;

implementation

{$R *.DFM}

procedure DrawScale;
const b_vstr : array[1..8,1..4] of char =(' <  ','-0.3','-0.1',' 0.2',' 0.5',' 0.8',' 1.3','>   ');
var
   xx,yy,i,ds,dsb,ds2,xmin,xmax,ymin,ymax,dx : integer;
   dma,ma : double;
begin
  with Scale.ClientRect do begin
     xmin := left; xmax := right-2;
     ymin := top; ymax := bottom-2;
  end;
  with Scale.PaintBox1.Canvas do begin
     Brush.Color := StarColor[0];
     Rectangle(xmin,ymin,xmax,ymax);
     Font.Name:='Small Fonts';
     Font.Size:=6;
     { toiles}
     dsb := 3+StarSize;
     dma := maxma/minvalue([Min_ma,maxma]);
     xx:=xmin; yy:=ymin+10; dx:=15;
     Pen.Color := StarColor[0];
     Pen.Width := 1;
     Font.Color := StarColor[11];
     for i:=0 to ceil(Min_ma) do begin
     xx := xx+dx;
     Brush.Color := StarColor[0];
     textout(xx-3,yy+8,inttostr(i));
     Brush.Color := StarColor[11];
     ma := minvalue([Min_ma,i])*dma;
     ds := round(dsb-ma*StarDyn/100);
     if ds<2 then ds:=2 ;
     ds2:= trunc(ds/2);
     case ds of
       1..2: Ellipse(xx,yy,xx+ds,yy+ds);
       3: Ellipse(xx-1,yy-1,xx+2,yy+2);
       4: Ellipse(xx-2,yy-2,xx+2,yy+2);
       5: Ellipse(xx-2,yy-2,xx+3,yy+3);
       6: Ellipse(xx-3,yy-3,xx+3,yy+3);
       7: Ellipse(xx-3,yy-3,xx+4,yy+4);
       else Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
     end;
     end;
     { Variables}
     xx:=xx+dx+dx;
     dx:=17;
     ds2:=5;
     Pen.Color:=StarColor[11];
     Brush.Color:=StarColor[0];
     Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
     ds2:=3;
     Pen.Color:=StarColor[0];
     Brush.Color:=StarColor[11];
     Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
     Brush.Color := StarColor[0];
     TextOut(xx-20,yy+8,'Variable');
     { Doubles }
     xx:=xx+dx+dx;
     ds2:=3;
     Pen.Color := clGray;
     Moveto(xx+ds2+3,yy-ds2-3);
     Lineto(xx,yy);
     Pen.Color:=StarColor[0];
     Brush.Color:=StarColor[11];
     Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
     Brush.Color := StarColor[0];
     TextOut(xx-20,yy+8,'Double');
     { couleurs }
     xx:=xx+dx;
     Pen.Color := StarColor[0];
     Brush.Color := StarColor[0];
     TextOut(xx-3,yy+8,'B-V :');
     xx:=xx+dx;
     ds2 := 5;
     for i:=1 to 7 do begin
        xx:=xx+dx;
        Brush.Color := StarColor[i];
        Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
        Brush.Color := StarColor[0];
        TextOut(xx-17,yy+8,b_vstr[i]);
     end;
     xx:=xx+dx;
     TextOut(xx-10,yy+8,b_vstr[8]);
  { Nbuleuses }
  xx:=xx+dx;
  ds:=6 ; ds2:=4;
  Pen.Width := 1;
  Brush.Color := StarColor[0];
  Pen.Color := StarColor[8];
  Ellipse(xx-ds,yy-ds2,xx+ds,yy+ds2);
  TextOut(xx-5,yy+8,'Gx');
  xx:=xx+dx;
  Pen.Color := StarColor[9];
  Ellipse(xx-ds,yy-ds,xx+ds,yy+ds);
  MoveTo(xx-ds,yy);
  LineTo(xx+ds,yy);
  TextOut(xx-5,yy+8,'Oc');
  xx:=xx+dx;
  Pen.Color := StarColor[9];
  Ellipse(xx-ds,yy-ds,xx+ds,yy+ds);
  MoveTo(xx-ds,yy);
  LineTo(xx+ds,yy);
  MoveTo(xx,yy-ds);
  LineTo(xx,yy+ds);
  TextOut(xx-5,yy+8,'Gc');
  xx:=xx+dx;
  Pen.Color := StarColor[10];
  Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
  TextOut(xx-5,yy+8,'Pl');
  xx:=xx+dx;
  Pen.Color := StarColor[10];
  Rectangle(xx-ds,yy-ds,xx+ds,yy+ds);
  TextOut(xx-5,yy+8,'Neb');
  xx:=xx+dx;
  Pen.Color := StarColor[10];
  Rectangle(xx-ds,yy-ds,xx+ds,yy+ds);
  MoveTo(xx-ds,yy);
  LineTo(xx+ds,yy);
  MoveTo(xx,yy-ds);
  LineTo(xx,yy+ds);
  TextOut(xx-5,yy+8,'N+C');
  xx:=xx+dx;
  Pen.Color := StarColor[9];
  MoveTo(xx-3+1,yy);
  LineTo(xx+3,yy);
  MoveTo(xx,yy-3+1);
  LineTo(xx,yy+3);
  TextOut(xx-5,yy+8,'Star');
  xx:=xx+dx;
  Pen.Color := StarColor[9];
  MoveTo(xx-1,yy-1);
  LineTo(xx+3,yy+3);
  MoveTo(xx-1,yy+2);
  LineTo(xx+3,yy-2);
  TextOut(xx-5,yy+8,'Unk');
  Pen.Color := StarColor[0];
   end;
end;

procedure TScale.FormPaint(Sender: TObject);
begin
 DrawScale;
end;

end.
