unit Sky_locate;

interface

uses
  SkyLib,IniFiles, Math,Registry,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, GIFImage, Menus;

Procedure SetLang;

type
  TSky_Locate1 = class(TForm)
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    Abandon: TBitBtn;
    BitBtn2: TBitBtn;
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    Image1: TImage;
    Image3: TImage;
    Image2: TImage;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    OpenDialog1: TOpenDialog;
    PopupMenu1: TPopupMenu;
    LoadWorldImage1: TMenuItem;
    DefaultWorldImage1: TMenuItem;
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AbandonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure LoadWorldImage1Click(Sender: TObject);
    procedure DefaultWorldImage1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Sky_Locate1: TSky_Locate1;
  ar,de : double;
  worldImage : string;

implementation

{$R *.DFM}

var  zoom : integer = 1;
     xx,yy : Integer;

const
cx=25.83333333333;
cy=1.722222222222;
crRetic = 5;

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='locate';
with Sky_Locate1 do
  with inifile do begin
    Label1.Caption:=ReadString(section,'t_1',deftxt);
    Caption:=ReadString(section,'t_2',deftxt);
    LoadWorldImage1.caption:=ReadString(section,'t_3',deftxt);
    DefaultWorldImage1.caption:=ReadString(section,'t_4',deftxt);
    BitBtn1.Caption:=ReadString('buttons','help',deftxt);
    abandon.Caption:=ReadString('buttons','close',deftxt);
  end;
inifile.free;
end;
end;

procedure DrawCross(color : Tcolor);
begin
xx:=trunc((24.0-ar)*cx);
yy:=trunc((90.0-de)*cy);
with Sky_Locate1.image2.Canvas do begin
  Pen.Width:=1;
  Brush.Style:=bsClear;
  Pen.Mode:=pmCopy;
  Pen.Color:=color;
  case zoom of
  1: begin
     Ellipse(xx-6,yy-6,xx+7,yy+7);
     MoveTo(xx-6,yy); LineTo(xx+7,yy);
     MoveTo(xx,yy-6); LineTo(xx,yy+7);
     end;
  2: begin
     Ellipse(xx-3,yy-3,xx+4,yy+4);
     MoveTo(xx-3,yy); LineTo(xx+4,yy);
     MoveTo(xx,yy-3); LineTo(xx,yy+4);
     end;
  4: begin
     MoveTo(xx-1,yy); LineTo(xx+2,yy);
     MoveTo(xx,yy-1); LineTo(xx,yy+2);
     end;
  8: begin
     pixels[xx,yy]:=color;
     end;
  end;
  Brush.Style:=bsSolid;
end;
end;

procedure TSky_Locate1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   DrawCross(clWhite);
   ar := 24-X/(cx*zoom) ;
   de := 90-Y/(cy*zoom) ;
   ModalResult := mrOK;
end;

procedure TSky_Locate1.AbandonClick(Sender: TObject);
begin
   DrawCross(clWhite);
   ModalResult := mrCancel;
end;

Function ChangeWorldImage: boolean;
begin
try
   Sky_Locate1.image3.Picture.LoadFromFile(worldimage);
   result:=true;
except
   result:=false;
end;
end;

procedure TSky_Locate1.FormShow(Sender: TObject);
var  Registry1: TRegistry;
begin
Panel1.width:=620;
Panel1.height:=310;
if image1.visible then begin
  image3.Free;
end
else if image3.Visible then begin
  image1.Free;
  worldimage:='';
  Registry1 := TRegistry.Create;
  with Registry1 do begin
   Openkey('Software\Astro_PC\Ciel\Config',true);
   if ValueExists('worldimage') then worldimage:=ReadString('worldimage');
   CloseKey;
  end;
  Registry1.Free;
  if worldimage<>'' then ChangeWorldImage;
end;
zoom:=1;
image2.BringToFront;
DrawCross(clRed);
image2.transparent:=true;
end;

procedure TSky_Locate1.FormCreate(Sender: TObject);
begin
SetLang;
//image2.Picture.Bitmap.PixelFormat:=pf8bit;
image2.Canvas.Brush.Style:=bsSolid;
image2.canvas.Brush.color:=clwhite;
image2.canvas.pen.color:=clwhite;
image2.canvas.fillrect(clientrect);
image2.Cursor := crRetic;
end;

procedure TSky_Locate1.BitBtn1Click(Sender: TObject);
begin
if image1<>nil then showhelp('doc1.html#position')
               else showhelp('doc3.html#observatoire');
end;

procedure TSky_Locate1.Image1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
if image1<>nil then label2.caption:=armtostr(24-X/(cx*zoom))+' '+demtostr(90-Y/(cy*zoom))
               else label2.caption:=demtostr((24-X/(cx*zoom))*15-180)+' '+demtostr(90-Y/(cy*zoom));
end;

procedure TSky_Locate1.BitBtn3Click(Sender: TObject);
begin
DrawCross(clWhite);
zoom:=min(8,2*zoom);
Panel1.width:=round(620*zoom);
Panel1.height:=round(310*zoom);
//image2.Picture.bitmap.Width:=panel1.width;
//image2.Picture.bitmap.height:=panel1.height;
DrawCross(clRed);
scrollbox1.HorzScrollBar.Position:=round(xx*zoom)-(scrollbox1.Width div 2);
scrollbox1.VertScrollBar.Position:=round(yy*zoom)-(scrollbox1.Height div 2);
end;

procedure TSky_Locate1.BitBtn2Click(Sender: TObject);
begin
DrawCross(clWhite);
zoom:=max(1,zoom div 2);
Panel1.width:=round(620*zoom);
Panel1.height:=round(310*zoom);
DrawCross(clRed);
scrollbox1.HorzScrollBar.Position:=round(xx*zoom)-(scrollbox1.Width div 2);
scrollbox1.VertScrollBar.Position:=round(yy*zoom)-(scrollbox1.Height div 2);
end;

procedure TSky_Locate1.BitBtn4Click(Sender: TObject);
begin
popupmenu1.popup(mouse.CursorPos.x,mouse.CursorPos.y);
end;

procedure TSky_Locate1.LoadWorldImage1Click(Sender: TObject);
var  Registry1: TRegistry;
begin
if opendialog1.execute then begin
   worldimage:=opendialog1.filename;
   if ChangeWorldImage then begin
   if 2*image3.Picture.Height<>image3.Picture.Width then
      Showmessage('The height/width proportion ratio for this image is not right, the position display can be totally wrong. Please load another image.')
   else begin
   Registry1 := TRegistry.Create;
   with Registry1 do begin
      Openkey('Software\Astro_PC\Ciel\Config',true);
      WriteString('worldimage',worldimage);
      CloseKey;
   end;
   Registry1.Free;
   end;
   end;
end;
end;

procedure TSky_Locate1.DefaultWorldImage1Click(Sender: TObject);
var  Registry1: TRegistry;
begin
   worldimage:='';
   Registry1 := TRegistry.Create;
   with Registry1 do begin
      Openkey('Software\Astro_PC\Ciel\Config',true);
      WriteString('worldimage',worldimage);
      CloseKey;
   end;
   Registry1.Free;
   Showmessage('You must now close and reopen this box');
end;

end.
