unit calendar1;

interface

Uses Windows, IniFiles, Registry, Sysutils;

Procedure Init1;
Procedure Init2;

var satpath,sattle : string;
    satmaglimit,satmagchart : double;
    satiridium : boolean;


implementation

Uses Skylib, Orbites, planning1;

procedure InitReg;
var ok: boolean;
    Registry1: TRegistry;
begin
sattle:='visual.tle';
satmaglimit:=3.5;
satmagchart:=6;
satiridium:=true;
language:='UK';
ObsNom:='Geneve';
ObsLongitude:=-6;
ObsLatitude:=46;
planetpath:='cat\planet';
planetparalaxe:=true;
AzNorth:=true;
Registry1 := TRegistry.Create;
with Registry1 do begin
  ok:=Openkey('Software\Astro_PC\Ciel\Config',false);
  if ok then begin
     if ValueExists('SatTle') then sattle:=ReadString('SatTle');
     if ValueExists('SatMagList') then satmaglimit:=ReadFloat('SatMagList');
     if ValueExists('SatMagChart') then satmagchart:=ReadFloat('SatMagChart');
     if ValueExists('SatIridium') then SatIridium:=ReadBool('SatIridium');
     if ValueExists('Language') then Language:=ReadString('Language') ;
     if trim(language)='' then language:='UK';
     if ValueExists('ObsNom') then ObsNom:=ReadString('ObsNom');
     if ValueExists('ObsLatitude') then ObsLatitude:=ReadFloat('ObsLatitude');
     if ValueExists('ObsLongitude') then ObsLongitude:=ReadFloat('ObsLongitude');
     if ValueExists('ObsAltitude') then ObsAltitude:=ReadFloat('ObsAltitude');
  end;
  CloseKey;
  ok:=Openkey('Software\Astro_PC\Ciel\Position',false);
  if ok then begin
     if ValueExists('AzNorth') then AzNorth:=ReadBool('AzNorth');
  end;
  CloseKey;
  ok:=Openkey('Software\Astro_PC\Ciel\Catalog',false);
  if ok then begin
     if ValueExists('Planetpath') then Planetpath:=ReadString('Planetpath');
  end;
  CloseKey;
end;
Registry1.Free;
end;


Procedure InitIni;
var
    inifile : Tinifile;
begin
if language>'0' then begin
inifile:=Tinifile.create(AppDir+'\language_'+language+'.ini');
with inifile do begin
    hp:=ReadString('main','help_prefix','');
    ldeg:=(ReadString('main','degree','')+'')[1];
    lmin:=(ReadString('main','minute','''')+'''')[1];
    lsec:=(ReadString('main','second','"')+'"')[1];
end;
inifile.free;
end;
end;

Function GetTimeBias : double;
var lt,st : TSystemTime;
begin
 GetLocalTime(lt);GetSystemTime(st);
 result:=round(24000000*(SystemTimeToDateTime(lt)-SystemTimeToDateTime(st)))/1000000;
end;

Procedure RefreshDate;
begin
 CurYear:=strtoint(Formatdatetime('yyyy',now));
 CurrentMonth:=strtoint(Formatdatetime('mm',now));
 CurrentDay:=strtoint(Formatdatetime('dd',now));
 CurrentTime:=strtofloat(Formatdatetime('h',now));
 CurrentTime:=CurrentTime+strtofloat(Formatdatetime('n',now))/60;
 CurrentTime:=CurrentTime+strtofloat(Formatdatetime('s',now))/3600;
 DT_UT:=DTminusUT(CurYear);
 TimeBias:=GetTimeBias;
end;

Procedure Init1;
begin
  getdir(0,appdir);
  decimalseparator:='.';
  SatPath:='cat\satellites';
  InitReg;
  InitIni;
  Skylib.Init;
  if useSeries96 then SetSeriesPath(PlanetPath);
  Orbites.Init;
  Orbites.LoadComete;
  RefreshDate;
end;

Procedure Init2;
begin
  planningform.tle.text:=sattle;
  planningform.maglimit.value:=satmaglimit;
  planningform.magchart.value:=satmagchart;
  planningform.iridiumbox.checked:=satiridium;
  planningform.satchartbox.checked:=false;
  planningform.satchartbox.visible:=false;
  chdir(appdir);
end;

end.
