Use Skylib;

begin
with Form1 do begin

// dimension de la fenetre 
with ClientRect do begin
    xmin := left; xmax := right;
    ymin := top; ymax := bottom;
end;

// position de la fenetre dans le ciel
arcentre:=10.25; // AR centre de la fenetre heure decimal
decentre:=34.0;  // DE centre de la fenetre
largeur:=10.0;   // largeur de la fenetre en degres
theta:=0.0;      // rotation de la fenetre
projtype:='A';   // projection de type ARC (voir projection() )

// calcul des parametres de projection  
Scalewindow; 

// plot d'une etoile 
DrawStar(10.5,32.0,5.0,0.3,canvas);

end;


Procedure DrawStar(ar,de,ma,b_v : Double; var out : Tcanvas);
var
  x1,y1: Double;
  ds,ds2,xx,yy,Icol : Integer;
  co : Tcolor;
  sma : string;
begin
with out do begin

   // transformation dans le referentiel centre sur la fenetre 
   projection(ar*15,de,arcentre*15,decentre,x1,y1) ;

   // valeurs en pixels 
   WindowXY(x1,y1,xx,yy);
   
   // etoile dans la fenetre ?
   if (xx>Xmin) and (xx<Xmax) and (yy>Ymin) and (yy<Ymax) then begin
   if not Invisible then begin

   // couleur du fond et de l'etoile en fonction de B-V
   Pen.Color := DrawColor[0];
   Pen.Width := DrawPen;
   Pen.Mode := pmCopy;
   Icol:=Round(b_v*10);
   case Icol of
         -999..-3: co := DrawColor[1];
           -2..-1: co := DrawColor[2];
            0..2 : co := DrawColor[3];
            3..5 : co := DrawColor[4];
            6..8 : co := DrawColor[5];
            9..13: co := DrawColor[6];
          14..900: co := DrawColor[7];
          else co:=DrawColor[11];
     end;
     Brush.Color := co ;

     // diametre du cercle en fonction de la magnitude
     ds := round(maxvalue([3,(starsize*(min_ma-ma*stardyn/80)/min_ma)])*drawsize);
     ds2:= round(ds/2);

     // plot de l'etoile 
     case ds of
       1..2: Ellipse(xx,yy,xx+ds,yy+ds);
       3: Ellipse(xx-1,yy-1,xx+2,yy+2);
       4: Ellipse(xx-2,yy-2,xx+2,yy+2);
       5: Ellipse(xx-2,yy-2,xx+3,yy+3);
       6: Ellipse(xx-3,yy-3,xx+3,yy+3);
       7: Ellipse(xx-3,yy-3,xx+4,yy+4);
       else Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
     end;
     end;
end;
end;
end;

