unit skyviewunit;

interface

uses SkyLib,IniFiles, Mydialog, HTTPsend, blcksock,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, ExtCtrls, Buttons,
  Mask, GIFImage;

Procedure SetLang;

type
  TSkyViewForm = class(TForm)
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Edit9: TEdit;
    Image1: TImage;
    ComboBox1: TComboBox;
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Memo1: TMemo;
    Label7: TLabel;
    BitBtn3: TBitBtn;
    DirectoryEdit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure SockStatus(Sender: TObject; Reason: THookSocketReason; Const Value: string) ;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure HttpError;
    procedure HttpSuccess;
  end;

var
  SkyViewForm: TSkyViewForm;
  arc,dec,champ : double;
  workdir,fitsfile : string;
  http: THTTPSend;


implementation

var   InfoUrl,cgi,survey,scoord,maproj,equinx,pixelx,pixely,smooth,namres,host,proxy,proxyport,proxyuser,proxypass : string;
      port,sockreadcount,sockwritecount : integer;
      locked : boolean;
      appmsg : array [1..3] of string;

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
    i : integer;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='skyview';
with SkyViewForm do
  with inifile do begin
    Label1.Caption:=ReadString(section,'t_2',deftxt);
    Label2.Caption:=ReadString(section,'t_3',deftxt);
    Label6.Caption:=ReadString(section,'t_4',deftxt);
    Label3.Caption:=ReadString(section,'t_5',deftxt);
    Label4.Caption:=ReadString(section,'t_6',deftxt);
    Label7.Caption:=ReadString(section,'t_7',deftxt);
    Label5.Caption:=ReadString(section,'t_8',deftxt);
    Memo1.lines[0]:=ReadString(section,'t_9',deftxt);
    BitBtn1.Caption:=ReadString(section,'t_1',deftxt);
    BitBtn2.Caption:=ReadString('buttons','close',deftxt);
    BitBtn3.Caption:=ReadString('buttons','help',deftxt);
    for i:=1 to 3 do begin
       appmsg[i]:=ReadString(section,'m_'+trim(inttostr(i)),deftxt);
    end;
  end;
inifile.free;
end;
end;

procedure InitString;
begin
appmsg[1]:='Dimension minimum';
appmsg[2]:='Vous devez entrer au moins le catalogue et les coordones';
appmsg[3]:='Interrompre le transfert ?';
end;

procedure TSkyViewForm.HttpError;
begin
edit6.Text:='Error: '+inttostr(http.ResultCode)+' '+http.ResultString;
end;

procedure TSkyViewForm.Button1Click(Sender: TObject);
var arg,buf : string;
begin
if locked then exit;
if (edit3.text<>'')and(strtoint(edit3.text)<50) then begin ShowMessage(appmsg[1]+' 50x50 pixels !');exit;end;
if (edit4.text<>'')and(strtoint(edit4.text)<50) then begin ShowMessage(appmsg[1]+' 50x50 pixels !');exit;end;
workdir:=DirectoryEdit1.Text;
if copy(workdir,length(workdir),1)<>'\' then workdir:=workdir+'\';
Listbox1.Clear;
if (combobox1.text='') or (edit2.text='') then Showmessage(appmsg[2])
else begin
arg:='VCOORD='+trim(edit2.text)
   +'&SURVEY='+trim(combobox1.text);
if scoord<>'' then arg:=arg+'&SCOORD='+trim(scoord);
if maproj<>'' then buf:=trim(maproj);
if edit9.text<>'' then if strtofloat(edit9.text)>85 then buf:='Rectangular';
if buf<>'' then arg:=arg+'&MAPROJ='+trim(buf);
if edit9.text<>'' then arg:=arg+'&SFACTR='+trim(edit9.text);
if equinx<>'' then arg:=arg+'&EQUINX='+trim(equinx);
if edit3.text<>'' then arg:=arg+'&PIXELX='+trim(edit3.text);
if edit4.text<>'' then arg:=arg+'&PIXELY='+trim(edit4.text);
if smooth<>'' then arg:=arg+'&SMOOTH='+trim(smooth);
if namres<>'' then arg:=arg+'&NAMRES='+trim(namres);
arg:=arg+'&PXLCNT=YES';
fitsfile:=changefileext(edit5.text,'.fit');
http.Clear;
sockreadcount:=0;
sockwritecount:=0;
http.TargetHost:=host;
http.TargetPort:=inttostr(port);
if proxy<>'' then http.ProxyHost:=proxy;
if proxyport<>'' then http.ProxyPort:=proxyport;
if proxyuser<>'' then http.ProxyUser :=proxyuser;
if proxypass<>'' then http.ProxyPass :=proxypass;
http.Sock.OnStatus:=sockstatus;
edit6.text:='Connect';
edit7.text:='';
locked:=true;
buf:=trim(host+cgi+'?'+arg);
buf:=stringreplace(buf,' ','%20',[rfReplaceAll]);
try
  if http.HTTPMethod('GET', buf)
     and ((http.ResultCode=200)
       or (http.ResultCode=0))
     then httpsuccess
     else httperror;
finally
http.Clear;
end;
locked:=false;
end;
end;

//skys.gsfc.nasa.gov/cgi-bin/pskcall?VCOORD=32.2308 , -11.1975&SURVEY=Digitized Sky Survey&SCOORD=Equatorial&MAPROJ=Gnonomic&SFACTR=1.000&EQUINX=2000&PIXELX=300&PIXELY=223&SMOOTH=1&NAMRES=SIMBAD/NED&PXLCNT=YES

procedure OpenUnixFile(var f : file; name : string);
begin
assignfile(f,name);
reset(f,1);
end;

procedure ReadUnixLine(var f : file; var line : string);
var c : char;
begin
line:='';
blockread(f,c,1);
while (c<>#10) and (not eof(f)) do begin
  line:=line+c;
  blockread(f,c,1);
end;
end;

procedure ReadHTMLText(var f : file; var line : string);
var c : char;
begin
line:='';
blockread(f,c,1);
while ((c<>#10) or (line='')) and (not eof(f)) do begin
  if c='<' then begin
     repeat blockread(f,c,1) until (c='>') or eof(f);
     blockread(f,c,1);
     continue;
  end;
  if c=#10 then begin blockread(f,c,1); continue; end;
  if c=#13 then begin blockread(f,c,1); continue; end;
  line:=line+c;
  blockread(f,c,1);
end;
end;

Procedure CloseUnixFile(var f : file);
begin
Closefile(f);
end;

Procedure ErrLst ;
var f : file;
    buf : string;
begin
OpenUnixFile(f,workdir+fitsfile);
SkyViewForm.Listbox1.Clear;
while not eof(f) do begin
  ReadHTMLText(f,buf);
  SkyViewForm.listbox1.Items.Add(buf);
end;
CloseUnixFile(f);
SkyViewForm.listbox1.TopIndex:=0;
end;

Procedure ExitOK;
begin
SkyViewForm.modalresult:=mrOK;
end;

procedure TSkyViewForm.HttpSuccess;
var head: array[1..8] of char;
    f : file;
begin
locked:=false;
http.Document.SaveToFile(workdir+fitsfile);
edit7.text:=edit7.text+', End';
filemode:=0;
assignfile(f,workdir+fitsfile);
reset(f,1);
BlockRead(f,head,8);
closefile(f);
if head<>'SIMPLE  ' then begin
  edit6.text:='Erreur';
  ErrLst;
end
else ExitOK;
edit6.refresh;
end;

procedure TSkyViewForm.FormCreate(Sender: TObject);
var inifile : Tinifile;
begin
workdir:=getcurrentdir;
InitString;
SetLang;
inifile:=Tinifile.create('.\extres.ini');
with inifile do begin
if SectionExists('skyview') then begin
Host:=ReadString('skyview','host',' ');
Port:=ReadInteger('skyview','port',0);
cgi:=ReadString('skyview','cgi',' ');
InfoUrl:=ReadString('skyview','info',' ');
end;
if SectionExists('proxy') then begin
proxy:=ReadString('proxy','proxy','');
proxyport:=ReadString('proxy','proxyport','');
proxyuser:=ReadString('proxy','proxyuser','');
proxypass:=ReadString('proxy','proxypass','');
end;
if SectionExists('default') then begin
survey:=ReadString('default','survey','');
scoord:=ReadString('default','scoord','');
maproj:=ReadString('default','maproj','');
equinx:=ReadString('default','equinx','');
pixelx:=ReadString('default','pixelx','');
pixely:=ReadString('default','pixely','');
smooth:=ReadString('default','smooth','');
namres:=ReadString('default','namres','');
end;
if SectionExists('survey') then begin
ReadSection('survey',combobox1.items);
end;
end;
inifile.free;
Memo1.lines[2]:=InfoUrl;
combobox1.text:=survey;
edit2.text:='';
edit3.text:=pixelx;
edit4.text:=pixely;
edit9.text:='';
Listbox1.Clear;
locked:=false;
arc:=0;
dec:=0;
champ:=0;
http := THTTPSend.Create;
end;

procedure TSkyViewForm.FormShow(Sender: TObject);
begin
edit6.text:='';
edit7.text:='';
Listbox1.Clear;
edit3.text:=pixelx;
edit4.text:=inttostr(round(strtoint(pixelx)/windowratio));
DirectoryEdit1.Text:=workdir;
if champ > 0 then edit9.text:=floattostrf(champ,ffFixed,7,3)
             else edit9.text:='';
edit2.text:=floattostrf(arc,ffFixed,8,4)+' , '+floattostrf(dec,ffFixed,8,4);
end;

procedure TSkyViewForm.SockStatus(Sender: TObject; Reason: THookSocketReason; Const Value: string) ;
var reasontxt:string;
begin
case reason of
HR_ResolvingBegin : reasontxt:='Resolving '+value;
HR_Connect        : reasontxt:='Connect '+value;
HR_Accept         : reasontxt:='Accept '+value;
HR_ReadCount      : begin
                    Sockreadcount:=Sockreadcount+strtoint(value);
                    reasontxt:='ReadCount '+inttostr(Sockreadcount);
                    end;
HR_WriteCount     : begin
                    Sockwritecount:=Sockwritecount+strtoint(value);
                    reasontxt:='WriteCount '+inttostr(Sockwritecount);
                    end;
else reasontxt:='';
end;
if reasontxt>'' then begin
  edit6.text:=reasontxt;
  edit6.refresh;
end;
end;

procedure TSkyViewForm.BitBtn2Click(Sender: TObject);
begin
if not locked then SkyViewForm.Close
else begin
 if MyMessageDlg(appmsg[3], mtConfirmation,[mbOk, mbCancel],0)=mrOK then begin
   locked:=false;
   HTTP.clear;
   Application.processmessages;
   SkyViewForm.Close;
 end;
end;
end;

procedure TSkyViewForm.Memo1Click(Sender: TObject);
begin
if infourl>'' then ExecuteFile(InfoUrl, '', '', SW_SHOWNOACTIVATE);
end;

procedure TSkyViewForm.BitBtn3Click(Sender: TObject);
begin
showhelp('doc3.html#skyview');
end;

procedure TSkyViewForm.FormDestroy(Sender: TObject);
begin
http.Free;
end;

end.
